local _, xBag = ...
local L = setmetatable({}, {__index = function(t, k)
local v = tostring(k)
rawset(t, k, v)
return v
end})
xBag.L = L
local locale = GetLocale()
xBag.Frames = {}
xBag.Functions = {}
xBag.Events = {}
xBag.Data = {}
function xBag.Functions.CreateData()
xBag.Data.PlayerID = UnitGUID("player")
if (xBagPerDB and xBagPerDB.PlayerID) then
if (xBagPerDB.PlayerID ~= xBag.Data.PlayerID) then xBagPerDB = nil; end
end
if (not xBagPerDB) then xBagPerDB = {}; end
if (not xBagPerDB.PlayerID) then xBagPerDB.PlayerID = xBag.Data.PlayerID; end
xBag.Data.MaxBags, xBag.Data.MaxFilters, xBag.Data.MaxBankFilters = 30, 19, 18
xBag.Data.ExtraBagsOpen = {}
xBag.Data.ExtraBankBagsOpen = {}
xBag.Data.BagList, xBag.Data.BankBagList = {}, {}
for i = 0, xBag.Data.MaxBags do xBag.Data.BagList[i], xBag.Data.BankBagList[i] = {}, {} end
xBag.Data.xSlotOffset, xBag.Data.xSlotOffsetBank = {}, {}
for i = 0, xBag.Data.MaxBags do xBag.Data.xSlotOffset[i], xBag.Data.xSlotOffsetBank[i] = 1, 1 end
xBag.Data.FilterNames = {L["Custom"], L["Crafting Reagents"], L["Reagents"], L["Chests"], L["BoP Gear & Bags"], L["BoE Gear & Bags"], L["Mounts/Pets/Toys"], L["Anima"], L["Korthian Relics"], L["Keys"], L["Recipes"], L["Enhancements"], L["Food & Drink"], L["Consumables"], L["Quest Items"], L["Readable"], L["Junk"], L["Miscellaneous"], L["New Items"]}
xBag.Data.SlotPickup = {["BagID"] = nil, ["SlotID"] = nil, ["isBank"] = nil, ["isReagent"] = nil, ["isInventory"] = nil}
local Tab = "      "
xBag.Data.GuideData1 = "|cff69ccf0"..L["UI Bag Bar"].."\n|r"..Tab..L["Left Click the big bag to toggle"].." |cffff7d0a"..L["Main Bag"].."|r\n"..Tab..L["Right Click the big bag to toggle all extra bags"].."\n"..Tab..L["Left click a small bag to toggle that bag"].."\n"..Tab..L["Shift + Left click a small bag to force show bag even when empty"].."\n"..Tab..L["Right click a small bag to set its bag"]
xBag.Data.GuideData2 = "\n\n\n|cff69ccf0"..L["Main Bag"].."\n|r"..Tab..L["Click"].."|cffff7d0a "..L["Sort And Filter"].." |r"..L["button to sort and filter bags"].."\n"..Tab..L["Click"].."|cffff7d0a "..L["Options"].." |r"..L["button to open options"].."\n\n|cfff8f996"..Tab..L["Extra Bags Bar"].."\n|r"..Tab..Tab..L["Left click bag to toggle extra bag"].."\n"..Tab..Tab..L["Shift + Left click bag to force show bag even when empty"].."\n"..Tab..Tab..L["Right click bag to create an extra bag/change filter"].."\n"..Tab..Tab..L["Selecting the same filter (yellow text) will remove that extra bag"].."\n"..Tab..Tab..L["Click Up/Down arrows or use scroll wheel to scroll through bags"].."\n"..Tab..Tab..L["Click"].." |cffff7d0a"..L["Toggle All"].." |r"..L["button to toggle all available extra bags"]
xBag.Data.GuideData3 = "\n\n\n|cff69ccf0"..L["Extra Bags"].."\n|cfff8f996"..Tab..L["Always Show"].."\n|cffffffff"..Tab..Tab..L["Check a bags"].." |cffff7d0a"..L["Always Show"].." |r"..L["box to mark it as Always Show"].."\n"..Tab..Tab..L["Bags marked as Always Show will open with Main Bag and be remembered between sessions"].." ("..L["unless"].."\n"..Tab..Tab.."|cffff7d0a"..L["Ignore Always Show"].." |r"..L["is set"]..")".."\n\n|cfff8f996"..Tab..L["Preset Filter"].."\n|cffffffff"..Tab..Tab..L["Appropriate items will automatically be filtered into this bag"].."\n\n|cfff8f996"..Tab..L["New Items Filter"].."\n|r"..Tab..Tab..L["Right click on the bags title to clear all new items"].."\n\n|cfff8f996"..Tab..L["Custom Filter"].."\n|r"..Tab..Tab..L["Right click on the bags title to rename"].."\n"..Tab..Tab..L["Add items by drag/drop or pickup/click onto the extra bags title"].."\n"..Tab..Tab..L["Move items around to reposition them"].."\n"..Tab..Tab..L["Swap items between custom bags, or move to the main bag to remove that item"].."\n\n"..Tab..Tab..L["Custom bags aren't affected by sorting, another bags filter or"].." |cffff7d0a"..L["Hide Empty Bags"].."|r"..L[", so the items stay in the"].."\n"..Tab..Tab..L["order you choose"].."\n"..Tab..Tab..L["For example:-  create a bag for your most frequently used items, or if you're farming something specific"].."\n"..Tab..Tab..L["create a bag just for that!"]
xBag.Data.GuideData4 = "\n\n\n|cff69ccf0"..L["Options"].."\n|r"..Tab..L["Enable/Disable automatic filtering (enabled is recommended as bags won't filter correctly while disabled)"].."\n"..Tab..L["Enable/Disable always showing junk items icon"].."\n"..Tab..L["Enable/Disable displaying extra bag names on extra bags bar"].."\n"..Tab..L["Enable/Disable hiding empty bags (Improved:- Empty bags will no longer display when created or toggled,"].."\n"..Tab..Tab..L["including Custom Bags)"].."\n"..Tab..L["Enable/Disable wait to resize active bag:- bag won't resize to smaller until cursor moves away from the bag"].."\n"..Tab..L["Enable/Disable un-marking a bag as"].." |cffff7d0a"..L["Always Show"].." |r"..L["when its filter changes"].."\n"..Tab..L["Enable/Disable ignoring"].." |cffff7d0a"..L["Always Show"].." |r"..L["settings"].."\n"..Tab..L["Enable/Disable automatic bag open/close with other events:- merchants, mailbox, etc"].."\n"..Tab..L["Enable/Disable automatic extra bags opening when looting"].."\n"..Tab..L["Enable/Disable remembering new items between sessions"].."\n"..Tab..L["Enable/Disable showing item levels"]
xBag.Data.GuideData5 = "\n\n\n|cff69ccf0"..L["Toggle All"].."\n|r"..Tab..L["Click the"].." |cffff7d0a"..L["Toggle All"].." |r"..L[" button, Right click the big bag or set a keybind"].."\n"..Tab..L["Toggle All will cycle through extra bags in the following order:-"].."  |cffffe00a"..L["Bags marked as Show All"].." |r".."/".." |cffffe00a"..L["All Bags"].." |r".."/".." |cffffe00a"..L["None"].."|r".."\n"..Tab.."|cffff7d0a"..L["Hide Empty Bags"].." |r"..L["setting also applies to Toggle All"]
xBag.Data.GuideData6 = "\n\n\n|cff69ccf0"..L["General"].."\n|r"..Tab..L["Use mouse wheel to scroll through bags contents  (holding down shift will page scroll, ctrl will full scroll)"].."\n"..Tab..L["Bank bag works pretty much the same as"].." |cffff7d0a"..L["Main Bag"].."\n|r"..Tab..L["Move"].." |cffff7d0a"..L["Main Bag"].."|r"..L[", Bank, Reagent Bank by dragging as normal"]
xBag.Data.GuideData7 = "\n\n\n|cff69ccf0"..L["Slash Commands"].."\n|cffffe00a"..Tab..L["/xbag open"].."|cffffffff  -  "..L["Turn xBag on"].."\n|cffffe00a"..Tab..L["/xbag close"].."|r  -  "..L["Turn xBag off and use default blizzard bags  (Use this option to change/equip new bags etc)"].."\n|cffffe00a"..Tab..L["/xbag binding"].."|r  -  "..L["Set Key Bindings"].."\n|cffffe00a"..Tab..L["/xbag help"].."|r  -  "..L["Show help"]
xBag.Data.GuideData = xBag.Data.GuideData1..xBag.Data.GuideData2..xBag.Data.GuideData3..xBag.Data.GuideData4..xBag.Data.GuideData5..xBag.Data.GuideData6..xBag.Data.GuideData7
if (xBagPerDB.xBagLoaded == nil) then xBagPerDB.xBagLoaded = true; end
if (not xBagPerDB.BagList) then
xBagPerDB.BagList, xBagPerDB.BankBagList, xBagPerDB.FilterList, xBagPerDB.BankFilterList, xBagPerDB.BagCustomList, xBagPerDB.BankCustomList = {}, {}, {}, {}, {}, {}
xBagPerDB.BagList[0], xBagPerDB.BankBagList[0] = {["Name"] = L["Main Bag"], ["Filter"] = nil}, {["Name"] = L["Main Bank"], ["Filter"] = nil}
for i = 1, xBag.Data.MaxBags do xBagPerDB.BagList[i], xBagPerDB.BankBagList[i], xBagPerDB.BagCustomList[i], xBagPerDB.BankCustomList[i] = {["Name"] = nil, ["Filter"] = nil}, {["Name"] = nil, ["Filter"] = nil}, {}, {} end
for i = 1, xBag.Data.MaxFilters do xBagPerDB.FilterList[i] = true end
for i = 1, xBag.Data.MaxBankFilters do xBagPerDB.BankFilterList[i] = true end
end
if (not xBagPerDB.UIBagButton) then xBagPerDB.UIBagButton = {1, 2, 3, 4, 5}; end
if (not xBagPerDB.AlwaysShowBag) then
xBagPerDB.AlwaysShowBag, xBagPerDB.AlwaysShowBank = {}, {}
for i = 1, xBag.Data.MaxBags do xBagPerDB.AlwaysShowBag[i], xBagPerDB.AlwaysShowBank[i] = false, false end
end
if (not xBagPerDB.SelectionButtonIndex) then xBagPerDB.SelectionButtonIndex, xBagPerDB.SelectionButtonIndexBank = 1, 1; end
if (not xBagPerDB.Bindings) then xBagPerDB.Bindings = {false, false, false, false, false, false, false}; end
if (not xBagPerDB.Options) then xBagPerDB.Options = {}; end
if (xBagPerDB.Options.FilterPickupBag == nil) then xBagPerDB.Options.FilterPickupBag = true; end
if (xBagPerDB.Options.FilterPickupBank == nil) then xBagPerDB.Options.FilterPickupBank = true; end
if (xBagPerDB.Options.ShowJunk == nil) then xBagPerDB.Options.ShowJunk = true; end
if (xBagPerDB.Options.ShowBagName == nil) then xBagPerDB.Options.ShowBagName = true; end
if (xBagPerDB.Options.HideEmptyBags == nil) then xBagPerDB.Options.HideEmptyBags = false; end
if (xBagPerDB.Options.NoResize == nil) then xBagPerDB.Options.NoResize = false; end
if (xBagPerDB.Options.RemoveShow == nil) then xBagPerDB.Options.RemoveShow = true; end
if (xBagPerDB.Options.IgnoreShow == nil) then xBagPerDB.Options.IgnoreShow = false; end
if (xBagPerDB.Options.RememberNew == nil) then xBagPerDB.Options.RememberNew = false; end
if (xBagPerDB.Options.ShowIlvl == nil) then xBagPerDB.Options.ShowIlvl = false; end
if (xBagPerDB.Options.LootOpen == nil) then xBagPerDB.Options.LootOpen = 2; end
if (xBagPerDB.Options.OpenBank == nil) then xBagPerDB.Options.OpenBank = true; end
if (xBagPerDB.Options.OpenMerchant == nil) then xBagPerDB.Options.OpenMerchant = true; end
if (xBagPerDB.Options.OpenMail == nil) then xBagPerDB.Options.OpenMail = true; end
if (xBagPerDB.Options.OpenAuction == nil) then xBagPerDB.Options.OpenAuction = true; end
if (xBagPerDB.Options.OpenGuildBank == nil) then xBagPerDB.Options.OpenGuildBank = true; end
if (xBagPerDB.Options.CloseBank == nil) then xBagPerDB.Options.CloseBank = true; end
if (xBagPerDB.Options.CloseMerchant == nil) then xBagPerDB.Options.CloseMerchant = true; end
if (xBagPerDB.Options.CloseMail == nil) then xBagPerDB.Options.CloseMail = true; end
if (xBagPerDB.Options.CloseAuction == nil) then xBagPerDB.Options.CloseAuction = true; end
if (xBagPerDB.Options.CloseGuildBank == nil) then xBagPerDB.Options.CloseGuildBank = true; end
end
function xBag.Functions.UpdateVersion()
if (not xBagPerDB.UpdateVersion) then
xBagPerDB.Options.HideEmptyBags = true
xBagPerDB.Options.RememberBagState = nil
xBagPerDB.MainOpened = nil
for i = 21, xBag.Data.MaxBags do xBagPerDB.BagList[i], xBagPerDB.BankBagList[i], xBagPerDB.BagCustomList[i], xBagPerDB.BankCustomList[i] = {["Name"] = nil, ["Filter"] = nil}, {["Name"] = nil, ["Filter"] = nil}, {}, {} end
xBag.Data.UpdateWarning = true
xBagPerDB.UpdateVersion = 1
end
if (xBagPerDB.UpdateVersion == 1) then
xBag.Data.UpdateWarning = true
xBagPerDB.UpdateVersion = 2
end
if (xBagPerDB.UpdateVersion == 2) then
if (xBagPerDB.FilterList[19] == nil) then xBagPerDB.FilterList[19] = true; end
local New
for i = 1, xBag.Data.MaxBags do
if (xBagPerDB.BagList[i].Filter == 19) then
if (not New) then New = true; else xBagPerDB.BagList[i].Name, xBagPerDB.BagList[i].Filter, xBagPerDB.AlwaysShowBag[i] = nil, nil, false; end
end
end
xBag.Data.UpdateWarning = true
xBagPerDB.UpdateVersion = 3
end
end
function xBag.Functions.UpdateWarning()
print("|cffffe00a"..L["Some option settings may have changed from a previous version.  Please check options / documentation"])
end
function xBag.Functions.CreateFunctions()
function xBag.Functions.AddNewItems()
xBagPerDB.NewItems = nil
xBagPerDB.NewItems = {}
for i = 0, NUM_BAG_SLOTS do
for x = 1, GetContainerNumSlots(i) do
if (C_NewItems.IsNewItem(i, x)) then
local _, Count, _, _, _, _, _, _, _, ItemID = GetContainerItemInfo(i, x)
if (ItemID) then table.insert(xBagPerDB.NewItems, {ItemID, Count}); end
end
end
end
if (xBag.Data.NewItems) then
for _, v in pairs(xBag.Data.NewItems) do
local Invalid
for _, vv in pairs(xBagPerDB.NewItems) do
if (vv[1] == v[1] and vv[2] == v[2]) then
Invalid = true
break
end
end
if (not Invalid) then table.insert(xBagPerDB.NewItems, {v[1], v[2]}); end
end
end
end
function xBag.Functions.ClearNewItems(ClearAll, BagIndex, SlotIndex)
if (ClearAll) then
C_NewItems.ClearAll()
local First, Last
for BagIndex = 0, NUM_BAG_SLOTS do
local BagID = IsBagOpen(BagIndex)
if (BagID) then
First, Last = 1, GetContainerNumSlots(BagIndex)
for SlotIndex = First, Last do
local ContainerIndex = Last - SlotIndex + 1
if (BagIndex == 0 and Last == 16) then ContainerIndex = ContainerIndex + 4; end
local Slot = _G["ContainerFrame"..BagID.."Item"..ContainerIndex]
local flash, newItemAnim = Slot.flashAnim, Slot.flashAnim
Slot.NewItemTexture:Hide()
if (flash:IsPlaying() or newItemAnim:IsPlaying()) then
flash:Stop()
newItemAnim:Stop()
end
end
end
end
xBag.Data.NewItems = nil
else
xBag.Functions.RemoveNewItem(BagIndex, SlotIndex)
if (xBag.Data.NewItems) then
local _, Count, _, _, _, _, _, _, _, ItemID = GetContainerItemInfo(BagIndex, SlotIndex)
if (ItemID) then
for i = 1, #xBag.Data.NewItems do
if (xBag.Data.NewItems[i][1] == ItemID and xBag.Data.NewItems[i][2] == Count) then
table.remove(xBag.Data.NewItems, i)
break
end
end
end
if (#xBag.Data.NewItems == 0) then xBag.Data.NewItems = nil; end
end
end
end
function xBag.Functions.HasNewFilter()
for i = 1, xBag.Data.MaxBags do if (xBagPerDB.BagList[i].Filter == 19) then return i; end end
return false
end
function xBag.Functions.ClearAllNewItems()
C_NewItems.ClearAll()
local First, Last
for BagIndex = 0, NUM_BAG_SLOTS do
local BagID = IsBagOpen(BagIndex)
if (BagID) then
First, Last = 1, GetContainerNumSlots(BagIndex)
for SlotIndex = First, Last do
local ContainerIndex = Last - SlotIndex + 1
if (BagIndex == 0 and Last == 16) then ContainerIndex = ContainerIndex + 4; end
local Slot = _G["ContainerFrame"..BagID.."Item"..ContainerIndex]
local flash, newItemAnim = Slot.flashAnim, Slot.flashAnim
Slot.NewItemTexture:Hide()
if (flash:IsPlaying() or newItemAnim:IsPlaying()) then
flash:Stop()
newItemAnim:Stop()
end
end
end
end
end
function xBag.Functions.SetBinding(Index, Set)
xBag.Frames.SetBinding:SetAttribute("Set", Set)
xBag.Frames.SetBinding:SetAttribute("Index", Index)
xBag.Frames.SetBinding:SetAttribute("Key", xBagPerDB.Bindings[Index])
CooldownFrame_Set(xBag.Frames.SetBinding, 1, 1, true)
end
function xBag.Functions.SetGlobals()
Item:CreateFromItemID(186200):ContinueOnItemLoad(function()
xBag.Frames.ScanTip:SetItemByID(186200)
xBag.Data.Anima = _G["xBagScanTipTextLeft2"]:GetText()
end)
Item:CreateFromItemID(186685):ContinueOnItemLoad(function()
xBag.Frames.ScanTip:SetItemByID(186685)
xBag.Data.KorthianRelic = _G["xBagScanTipTextLeft2"]:GetText()
end)
Item:CreateFromItemID(172179):ContinueOnItemLoad(function()
xBag.Frames.ScanTip:SetItemByID(172179)
xBag.Data.Toy = _G["xBagScanTipTextLeft3"]:GetText()
end)
end
function xBag.Functions.SetBagFilter()
local HasFilter = GetBankAutosortDisabled() or GetBackpackAutosortDisabled()
if (not HasFilter) then
for i = 1, NUM_BAG_SLOTS + NUM_BANKBAGSLOTS do
if (i > NUM_BAG_SLOTS) then
if (GetBankBagSlotFlag(i - NUM_BAG_SLOTS, LE_BAG_FILTER_FLAG_IGNORE_CLEANUP) or GetBankBagSlotFlag(i - NUM_BAG_SLOTS, LE_BAG_FILTER_FLAG_EQUIPMENT) or GetBankBagSlotFlag(i - NUM_BAG_SLOTS, LE_BAG_FILTER_FLAG_CONSUMABLES) or GetBankBagSlotFlag(i - NUM_BAG_SLOTS, LE_BAG_FILTER_FLAG_TRADE_GOODS)) then
HasFilter = true
break
end
else
if (GetBagSlotFlag(i, LE_BAG_FILTER_FLAG_IGNORE_CLEANUP) or GetBagSlotFlag(i, LE_BAG_FILTER_FLAG_EQUIPMENT) or GetBagSlotFlag(i, LE_BAG_FILTER_FLAG_CONSUMABLES) or GetBagSlotFlag(i, LE_BAG_FILTER_FLAG_TRADE_GOODS)) then
HasFilter = true
break
end
end
end
end
if (HasFilter) then
local Value = false
local Time = 1
if (GetBankAutosortDisabled()) then SetBankAutosortDisabled(Value); end
if (GetBackpackAutosortDisabled()) then SetBackpackAutosortDisabled(Value); end
for i = 1, NUM_BAG_SLOTS do
if (GetBagSlotFlag(i, LE_BAG_FILTER_FLAG_IGNORE_CLEANUP)) then
C_Timer.After(Time, function() SetBagSlotFlag(i, LE_BAG_FILTER_FLAG_IGNORE_CLEANUP, Value) end)
Time = Time + 1
end
end
for i = 1, NUM_BAG_SLOTS do
if (GetBagSlotFlag(i, LE_BAG_FILTER_FLAG_EQUIPMENT) or GetBagSlotFlag(i, LE_BAG_FILTER_FLAG_CONSUMABLES) or GetBagSlotFlag(i, LE_BAG_FILTER_FLAG_TRADE_GOODS)) then
C_Timer.After(Time, function() SetBagSlotFlag(i, LE_BAG_FILTER_FLAG_EQUIPMENT, Value) end)
Time = Time + 1
end
end
for i = 1, NUM_BANKBAGSLOTS do
if (GetBankBagSlotFlag(i, LE_BAG_FILTER_FLAG_IGNORE_CLEANUP)) then
C_Timer.After(Time, function() SetBankBagSlotFlag(i, LE_BAG_FILTER_FLAG_IGNORE_CLEANUP, Value) end)
Time = Time + 1
end
end
for i = 1, NUM_BANKBAGSLOTS do
if (GetBankBagSlotFlag(i, LE_BAG_FILTER_FLAG_EQUIPMENT) or GetBankBagSlotFlag(i, LE_BAG_FILTER_FLAG_CONSUMABLES) or GetBankBagSlotFlag(i, LE_BAG_FILTER_FLAG_TRADE_GOODS)) then
C_Timer.After(Time, function() SetBankBagSlotFlag(i, LE_BAG_FILTER_FLAG_EQUIPMENT, Value) end)
Time = Time + 1
end
end
end
end
function xBag.Functions.SetBagName(Label, Name)
Label:SetText(Name)
if (Label:GetWidth() > 54) then
repeat
Name = Name:sub(1, -2)
Label:SetText(Name.."..")
until Label:GetWidth() <= 54
end
end
function xBag.Functions.SetBagTitleName(Label, Name)
Label:SetText(Name)
if (Label:GetWidth() > 116) then
repeat
Name = Name:sub(1, -2)
Label:SetText(Name.."..")
until Label:GetWidth() <= 116
end
end
function xBag.Functions.UIBagButtonClick(Self)
local ID = xBagPerDB.UIBagButton[Self:GetID()]
if (not xBagPerDB.BagList[ID].Filter) then return; end
local SetBags
if (not xBag.Frames.ExtraBag[0]:IsShown()) then
SetBags = true
for i = 1, xBag.Data.MaxBags do
if (xBag.Frames.ExtraBag[i]:IsShown()) then
SetBags = false
break
end
end
if (SetBags) then
for i = 0, xBag.Data.MaxBags do wipe(xBag.Data.BagList[i]) end
xBag.Functions.OpenCloseBags(false, true)
if ((not xBagPerDB.Options.HideEmptyBags) or (xBagPerDB.Options.HideEmptyBags and ((xBag.Frames.ExtraBag[ID]:IsShown() or #xBag.Data.BagList[ID] > 0) or IsShiftKeyDown()))) then
xBag.Data.CloseCheck = true
wipe(xBag.Data.ExtraBagsOpen)
end
end
end
if ((not xBagPerDB.Options.HideEmptyBags) or (xBagPerDB.Options.HideEmptyBags and ((xBag.Frames.ExtraBag[ID]:IsShown() or #xBag.Data.BagList[ID] > 0) or IsShiftKeyDown()))) then
xBag.Frames.ExtraBag[ID]:SetShown(not xBag.Frames.ExtraBag[ID]:IsShown())
else
if (SetBags) then xBag.Functions.OpenCloseBags(false, false); end
end
end
function xBag.Functions.EventBagShow()
if (not xBag.Frames.ExtraBag[0]:IsShown()) then xBag.Frames.ExtraBag[0]:Show(); end
end
function xBag.Functions.ToggleBag()
xBag.Frames.ExtraBag[0]:SetShown(not xBag.Frames.ExtraBag[0]:IsShown())
end
function xBag.Functions.OpenCloseBags(isBank, isOpen)
local First, Last = 0, NUM_BAG_SLOTS
if (isBank) then First, Last = NUM_BAG_SLOTS + 1, NUM_BAG_SLOTS + NUM_BANKBAGSLOTS; end
for i = First, Last do if (isOpen) then OpenBag(i); else CloseBag(i); end end
if (isOpen) then xBag.Functions.FilterBags(isBank); elseif (isBank) then CloseBankFrame(); end
end
function xBag.Functions.GetBagIndex(ID, isBank)
local Col, Row, FirstIndex, LastIndex = 4, 6
if (ID == 0) then Col, Row = 8, 10; end
local MaxSlots = Col * Row
if (isBank) then
FirstIndex = xBag.Data.xSlotOffsetBank[ID]
LastIndex = math.min((FirstIndex - 1) + MaxSlots, #xBag.Data.BankBagList[ID])
else
FirstIndex = xBag.Data.xSlotOffset[ID]
LastIndex = math.min((FirstIndex - 1) + MaxSlots, #xBag.Data.BagList[ID])
end
return FirstIndex, LastIndex
end
function xBag.Functions.UpdateBags(isBank, ID, FirstIndex, LastIndex)
local InitLeft, InitTop, ColSize = 1, 0, 4
if (ID == 0) then InitLeft, InitTop, ColSize = 0, -97, 8; end
local Left, Top, Index, BagData, Parent = InitLeft, InitTop, 1
if (isBank) then BagData, Parent = xBag.Data.BankBagList[ID], xBag.Frames.BankBag[ID].Display; else BagData, Parent = xBag.Data.BagList[ID], xBag.Frames.ExtraBag[ID].Display; end
for i = 1, #BagData do
BagData[i]:ClearAllPoints()
if (isBank and BagData[i].xParent == BankSlotsFrame) then BagData[i]:SetParent(Parent); end
if (i >= FirstIndex and i <= LastIndex) then
BagData[i].xID = Parent:GetParent():GetID()
BagData[i]:SetPoint("TOPLEFT", Parent, "TOPLEFT", Left, Top)
BagData[i]:SetShown(Parent:IsVisible())
if (xBagPerDB.Options.ShowIlvl) then
local ILvl
local BagID, SlotID = BagData[i]:GetParent():GetID(), BagData[i]:GetID()
local ItemLink = GetContainerItemLink(BagID, SlotID)
if (ItemLink) then
local _, _, _, EquipLoc, _, _, _ = GetItemInfoInstant(ItemLink)
if (EquipLoc ~= "" and EquipLoc ~= "INVTYPE_BAG") then ILvl = GetDetailedItemLevelInfo(ItemLink); end
end
if (ILvl) then
BagData[i].xLvl:SetText(ILvl)
BagData[i].xLvl:Show()
else
BagData[i].xLvl:Hide()
end
else
BagData[i].xLvl:Hide()
end
if (Index == ColSize) then Index, Left, Top = 1, InitLeft, Top - 37 - 5; else Index, Left = Index + 1, Left + 37 + 5; end
else
BagData[i]:Hide()
end
end
end
function xBag.Functions.ListScroll(Self, Delta, isBank)
local ID, Size, Offset = Self:GetID()
if (isBank) then Size, Offset = #xBag.Data.BankBagList[ID], xBag.Data.xSlotOffsetBank[ID]; else Size, Offset = #xBag.Data.BagList[ID], xBag.Data.xSlotOffset[ID]; end
if (Size < 1) then return; end
local Col, Row = 4, 6
if (ID == 0) then Col, Row = 8, 10; end
local MaxSlots, Update = (Col * Row)
if (Delta == -1) then
if ((Offset - 1) + MaxSlots < Size) then
if (IsShiftKeyDown()) then
if (isBank) then xBag.Data.xSlotOffsetBank[ID] = xBag.Data.xSlotOffsetBank[ID] + MaxSlots; else xBag.Data.xSlotOffset[ID] = xBag.Data.xSlotOffset[ID] + MaxSlots; end
local FirstIndex, LastIndex = xBag.Functions.GetBagIndex(ID, isBank)
local Value = MaxSlots - ((LastIndex - FirstIndex) + 1)
if (Value > 0) then if (isBank) then xBag.Data.xSlotOffsetBank[ID] = math.max(xBag.Data.xSlotOffsetBank[ID] - (Value - (Value % Col)), 1); else xBag.Data.xSlotOffset[ID] = math.max(xBag.Data.xSlotOffset[ID] - (Value - (Value % Col)), 1); end; end
elseif (IsControlKeyDown()) then
if (isBank) then xBag.Data.xSlotOffsetBank[ID] = math.max(Size - ((MaxSlots - 1) - (Col - (Size % Col))), 1); else xBag.Data.xSlotOffset[ID] = math.max(Size - ((MaxSlots - 1) - (Col - (Size % Col))), 1); end
else
if (isBank) then xBag.Data.xSlotOffsetBank[ID] = xBag.Data.xSlotOffsetBank[ID] + Col; else xBag.Data.xSlotOffset[ID] = xBag.Data.xSlotOffset[ID] + Col; end
end
Update = true
end
else
if (Offset > Col) then
if (IsShiftKeyDown()) then
if (isBank) then xBag.Data.xSlotOffsetBank[ID] = math.max(xBag.Data.xSlotOffsetBank[ID] - MaxSlots, 1) else xBag.Data.xSlotOffset[ID] = math.max(xBag.Data.xSlotOffset[ID] - MaxSlots, 1); end
elseif (IsControlKeyDown()) then
if (isBank) then xBag.Data.xSlotOffsetBank[ID] = 1; else xBag.Data.xSlotOffset[ID] = 1; end
else
if (isBank) then xBag.Data.xSlotOffsetBank[ID] = xBag.Data.xSlotOffsetBank[ID] - Col; else xBag.Data.xSlotOffset[ID] = xBag.Data.xSlotOffset[ID] - Col; end
end
Update = true
end
end
if (Update) then xBag.Functions.UpdateBags(isBank, ID, xBag.Functions.GetBagIndex(ID, isBank)); end
end
function xBag.Functions.FindExtraBag(ID, isBank)
local Data
if (isBank) then Data = xBag.Data.ExtraBankBagsOpen; else Data = xBag.Data.ExtraBagsOpen; end
for k, v in ipairs(Data) do if (v == ID) then return k; end end
end
function xBag.Functions.SetExtraBag(isBank)
local yOffset, yOffsetBase, xOffset, MaxHeight, Open, Bag, Value, Point1, Point2, Parent = 0, 0
if (isBank) then
xOffset, MaxHeight, Open, Bag, Value, Point1, Point2, Parent = 11, xBag.Frames.BankBag[0]:GetHeight(), xBag.Data.ExtraBankBagsOpen, xBag.Frames.BankBag, 205, "BOTTOMLEFT", "BOTTOMRIGHT", xBag.Frames.BankBag[0]
else
Open, Bag, Value, Point1 = xBag.Data.ExtraBagsOpen, xBag.Frames.ExtraBag, -205, "BOTTOMRIGHT"
if (xBag.Frames.ExtraBag[0]:IsShown()) then
xOffset, MaxHeight, Point2, Parent = -11, xBag.Frames.ExtraBag[0]:GetHeight() + 100, "BOTTOMLEFT", xBag.Frames.ExtraBag[0]
else
yOffset, yOffsetBase, MaxHeight, Point2, Parent = 100, 100, xBag.Frames.ExtraBag[0]:GetHeight() + 150, "BOTTOMRIGHT", UIParent
xOffset = -9
if (MultiBarLeft:IsShown()) then xOffset = xOffset - MultiBarLeft:GetWidth(); end
if (MultiBarRight:IsShown()) then xOffset = xOffset - MultiBarRight:GetWidth(); end
end
end
for i = 1, #Open do
if (i > 1) then
yOffset = yOffset + Bag[Open[i - 1]]:GetHeight() + 19
if (yOffset + Bag[Open[i]]:GetHeight() > MaxHeight) then yOffset, xOffset = yOffsetBase, xOffset + Value; end
end
Bag[Open[i]]:ClearAllPoints()
Bag[Open[i]]:SetPoint(Point1, Parent, Point2, xOffset, yOffset)
end
end
function xBag.Functions.BagScroll(Delta, isBank)
if (UIDROPDOWNMENU_OPEN_MENU and UIDROPDOWNMENU_OPEN_MENU.xMenu) then CloseDropDownMenus(); end
if (isBank) then
if (Delta == 1) then
if (xBagPerDB.SelectionButtonIndexBank == 26) then xBagPerDB.SelectionButtonIndexBank = 1; else xBagPerDB.SelectionButtonIndexBank = xBagPerDB.SelectionButtonIndexBank + 5; end
else
if (xBagPerDB.SelectionButtonIndexBank == 1) then xBagPerDB.SelectionButtonIndexBank = 26; else xBagPerDB.SelectionButtonIndexBank = xBagPerDB.SelectionButtonIndexBank - 5; end
end
for i = 1, xBag.Data.MaxBags do xBag.Frames.BankBag[0].BagSelectionButton[i]:SetShown(i >= xBagPerDB.SelectionButtonIndexBank and i <= (xBagPerDB.SelectionButtonIndexBank + 4)) end
else
if (Delta == 1) then
if (xBagPerDB.SelectionButtonIndex == 26) then xBagPerDB.SelectionButtonIndex = 1; else xBagPerDB.SelectionButtonIndex = xBagPerDB.SelectionButtonIndex + 5; end
else
if (xBagPerDB.SelectionButtonIndex == 1) then xBagPerDB.SelectionButtonIndex = 26; else xBagPerDB.SelectionButtonIndex = xBagPerDB.SelectionButtonIndex - 5; end
end
for i = 1, xBag.Data.MaxBags do xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetShown(i >= xBagPerDB.SelectionButtonIndex and i <= (xBagPerDB.SelectionButtonIndex + 4)) end
end
end
function xBag.Functions.ResizeBag(ID, isBank)
local Rows, Bag
if (isBank) then Rows, Bag = math.max(math.min(math.ceil(#xBag.Data.BankBagList[ID] / 4), 6), 1), xBag.Frames.BankBag; else Rows, Bag = math.max(math.min(math.ceil(#xBag.Data.BagList[ID] / 4), 6), 1), xBag.Frames.ExtraBag; end
if (Bag[ID].xRows == Rows) then return; end
Bag[ID].xRows = Rows
Bag[ID]:SetHeight(45 + (Rows * 42))
end
function xBag.Functions.RefreshBags(isBank)
local BagList, Offset, Bag
if (isBank) then BagList, Offset, Bag = xBag.Data.BankBagList, xBag.Data.xSlotOffsetBank, xBag.Frames.BankBag; else BagList, Offset, Bag = xBag.Data.BagList, xBag.Data.xSlotOffset, xBag.Frames.ExtraBag; end
local Data = {}
for i = 0, xBag.Data.MaxBags do
Data[i] = #BagList[i]
wipe(BagList[i])
end
xBag.Functions.FilterBags(isBank)
local Col
for i = 0, xBag.Data.MaxBags do
if (#BagList[i] < Data[i]) then
if (i == 0) then Col = 8; else Col = 4; end
Offset[i] = math.max(Offset[i] - ((math.floor((Data[i] - #BagList[i]) / Col)) * Col), 1)
if (#BagList[i] >= 24) then
xBag.Functions.ListScroll(Bag[i], 1, isBank)
xBag.Functions.ListScroll(Bag[i], -1, isBank)
end
end
if (i > 0) then
if (not xBagPerDB.Options.NoResize) then
xBag.Functions.ResizeBag(i, isBank)
else
if (#BagList[i] < Data[i] and Bag[i]:IsMouseOver()) then Bag[i].xResize = true; else xBag.Functions.ResizeBag(i, isBank); end
end
end
xBag.Functions.UpdateBags(isBank, i, xBag.Functions.GetBagIndex(i, isBank))
end
xBag.Functions.SetExtraBag(isBank)
end
function xBag.Functions.UpdateFilters(isBank, Add, BagID, FilterID, Index)
local BagList, FilterList, Bag, CustomList, AlwaysShow
if (isBank) then BagList, FilterList, Bag, CustomList, AlwaysShow = xBagPerDB.BankBagList, xBagPerDB.BankFilterList, xBag.Frames.BankBag, xBagPerDB.BankCustomList, xBagPerDB.AlwaysShowBank; else BagList, FilterList, Bag, CustomList, AlwaysShow = xBagPerDB.BagList, xBagPerDB.FilterList, xBag.Frames.ExtraBag, xBagPerDB.BagCustomList, xBagPerDB.AlwaysShowBag; end
if (Add) then
if (BagList[BagID].Filter == 1) then wipe(CustomList[BagID]); end
BagList[BagID].Name, BagList[BagID].Filter, FilterList[FilterID] = nil, nil, true
if (Bag[BagID]:IsShown()) then Bag[BagID]:Hide(); end
AlwaysShow[BagID] = false
Bag[BagID].AlwaysShow:SetChecked(false)
else
if (FilterID) then
FilterList[FilterID] = true
if (BagList[BagID].Filter == 1) then wipe(CustomList[BagID]); end
end
if (Index ~= 1) then FilterList[Index] = false; end
BagList[BagID].Name = xBag.Data.FilterNames[Index]
BagList[BagID].Filter = Index
if (not Bag[BagID]:IsShown()) then Bag[BagID]:Show(); end
if (xBagPerDB.Options.RemoveShow) then
AlwaysShow[BagID] = false
Bag[BagID].AlwaysShow:SetChecked(false)
end
end
if (not isBank) then
xBag.Data.NewFilter = xBag.Functions.HasNewFilter()
if (xBag.Data.NewFilter) then
C_NewItems.RemoveNewItem = function() end
else
C_NewItems.RemoveNewItem = xBag.Functions.RemoveNewItem
xBag.Functions.ClearNewItems(true)
end
end
xBag.Functions.SetBagTitleName(Bag[BagID].Title, BagList[BagID].Name)
xBag.Functions.SetBagName(Bag[0].BagSelectionButton[BagID].Name, BagList[BagID].Name)
Bag[0].BagSelectionButton[BagID].Disabled:SetShown(not BagList[BagID].Filter)
if (not isBank) then
for x = 1, 5 do
if (xBagPerDB.UIBagButton[x] == BagID) then
xBag.Frames.UIBagButton[x].Disabled:SetShown(not BagList[BagID].Filter)
break
end
end
end
xBag.Functions.RefreshBags(isBank)
end
function xBag.Functions.ToggleAll(isBank)
local AllBagsList, AlwaysShownList, AllBags, AlwaysShown, BagList, BagListData, Bag, AlwaysShow = {}, {}, 0, 0
if (isBank) then BagList, BagListData, Bag, AlwaysShow = xBagPerDB.BankBagList, xBag.Data.BankBagList, xBag.Frames.BankBag, xBagPerDB.AlwaysShowBank; else BagList, BagListData, Bag, AlwaysShow = xBagPerDB.BagList, xBag.Data.BagList, xBag.Frames.ExtraBag, xBagPerDB.AlwaysShowBag; end
if (not isBank) then
if (not xBag.Frames.ExtraBag[0]:IsShown()) then
for i = 0, xBag.Data.MaxBags do wipe(xBag.Data.BagList[i]) end
xBag.Functions.OpenCloseBags(false, true)
xBag.Data.CloseCheck = true
end
end
for i = 1, xBag.Data.MaxBags do
if (BagList[i].Filter and ((not xBagPerDB.Options.HideEmptyBags) or (xBagPerDB.Options.HideEmptyBags and #BagListData[i] > 0))) then
table.insert(AllBagsList, Bag[i])
if (Bag[i]:IsShown()) then AllBags = AllBags + 1; end
if (AlwaysShow[i]) then
table.insert(AlwaysShownList, Bag[i])
if (Bag[i]:IsShown()) then AlwaysShown = AlwaysShown + 1; end
end
else
if (Bag[i]:IsShown()) then Bag[i]:Hide(); end
end
end
if (#AllBagsList == 0) then return; end
if (not isBank and #AllBagsList ~= AllBags) then
if (not xBag.Frames.ExtraBag[0]:IsShown()) then
for i = 1, xBag.Data.MaxBags do if (Bag[i]:IsShown()) then Bag[i]:Hide(); end end
for i = 0, xBag.Data.MaxBags do wipe(xBag.Data.BagList[i]) end
xBag.Functions.OpenCloseBags(false, true)
xBag.Data.CloseCheck = true
end
end
if (#AllBagsList == AllBags) then
for i = 1, xBag.Data.MaxBags do if (Bag[i]:IsShown()) then Bag[i]:Hide(); end end
elseif (AlwaysShown < #AlwaysShownList) then
for i = 1, xBag.Data.MaxBags do if (Bag[i]:IsShown()) then Bag[i]:Hide(); end end
for i = 1, #AlwaysShownList do AlwaysShownList[i]:Show() end
else
for i = 1, xBag.Data.MaxBags do if (Bag[i]:IsShown()) then Bag[i]:Hide(); end end
for i = 1, #AllBagsList do AllBagsList[i]:Show() end
end
end
function xBag.Functions.OpenExtraBag(ID, isBank)
if (isBank) then
xBag.Frames.BankBag[0].BagSelectionButton[ID]:SetButtonState("PUSHED", true)
table.insert(xBag.Data.ExtraBankBagsOpen, ID)
else
xBag.Frames.ExtraBag[0].BagSelectionButton[ID]:SetButtonState("PUSHED", true)
table.insert(xBag.Data.ExtraBagsOpen, ID)
end
xBag.Functions.SetExtraBag(isBank)
end
function xBag.Functions.CloseExtraBag(ID, isBank)
local Bag, Open, BagList
if (isBank) then Bag, Open, BagList = xBag.Frames.BankBag, xBag.Data.ExtraBankBagsOpen, xBag.Data.BankBagList; else Bag, Open, BagList = xBag.Frames.ExtraBag, xBag.Data.ExtraBagsOpen, xBag.Data.BagList; end
Bag[0].BagSelectionButton[ID]:SetButtonState("NORMAL", false)
local Index = xBag.Functions.FindExtraBag(ID, isBank)
table.remove(Open, Index)
xBag.Functions.SetExtraBag(isBank)
if (#BagList[ID] > 0) then for _, v in pairs(BagList[ID]) do v:Hide() end end
end
function xBag.Functions.ToggleReagentBank()
if (IsReagentBankUnlocked()) then xBag.Frames.ReagentBag:SetShown(not xBag.Frames.ReagentBag:IsShown()); end
end
function xBag.Functions.xBagMove(Self)
if (Self == xBag.Frames.ExtraBag[0] or Self == xBag.Frames.ExtraBag[0].Header) then
xBag.Frames.ExtraBag[0]:StopMovingOrSizing()
xBagPerDB.MainBagPoints = {xBag.Frames.ExtraBag[0]:GetPoint()}
elseif (Self == xBag.Frames.BankBag[0] or Self == xBag.Frames.BankBag[0].Header) then
xBag.Frames.BankBag[0]:StopMovingOrSizing()
xBagPerDB.MainBankBagPoints = {xBag.Frames.BankBag[0]:GetPoint()}
else
xBag.Frames.ReagentBag:StopMovingOrSizing()
xBagPerDB.ReagentBankPoints = {xBag.Frames.ReagentBag:GetPoint()}
end
end
function xBag.Functions.InitMenu(Self, Level, isBank)
if (not Self.xIndex) then return; end
local BagID, BagList, FilterList, MaxFilters = Self.xIndex
if (isBank) then BagList, FilterList, MaxFilters = xBagPerDB.BankBagList, xBagPerDB.BankFilterList, xBag.Data.MaxBankFilters; else BagList, FilterList, MaxFilters = xBagPerDB.BagList, xBagPerDB.FilterList, xBag.Data.MaxFilters; end
local FilterID = BagList[BagID].Filter
Level = Level or 1
local Info = UIDropDownMenu_CreateInfo()
if (Level == 1) then
Info.notCheckable = true
if (FilterID) then
Info.text = "|cffffe00a"..xBag.Data.FilterNames[FilterID]
Info.func = function() xBag.Functions.UpdateFilters(isBank, true, BagID, FilterID) end
UIDropDownMenu_AddButton(Info, Level)
end
for i = 1, MaxFilters do
if (FilterList[i] and BagList[BagID].Filter ~= i) then
Info.text = xBag.Data.FilterNames[i]
Info.func = function()
xBag.Functions.UpdateFilters(isBank, false, BagID, FilterID, i)
if (xBagPerDB.Options.HideEmptyBags) then
local Empty, Bag
if (isBank) then Bag, Empty = xBag.Frames.BankBag[BagID], #xBag.Data.BankBagList[BagID] == 0; else Bag, Empty = xBag.Frames.ExtraBag[BagID], #xBag.Data.BagList[BagID] == 0; end
if (Empty and BagList[BagID].Filter ~= 1) then Bag:Hide(); end
end
end
UIDropDownMenu_AddButton(Info, Level)
end
end
end
end
function xBag.Functions.InitOptionsMenu(Self, Level)
Level = Level or 1
local Info = UIDropDownMenu_CreateInfo()
if (Level == 1) then
Info.keepShownOnClick = true
Info.isNotRadio = true
Info.text = L["Filter Bags As Contents Change"].."   |cffffe00a("..L["recommended"]..")"
Info.checked = xBagPerDB.Options.FilterPickupBag
Info.func = function() xBagPerDB.Options.FilterPickupBag = not xBagPerDB.Options.FilterPickupBag end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Filter Bank As Contents Change"].."   |cffffe00a("..L["recommended"]..")"
Info.checked = xBagPerDB.Options.FilterPickupBank
Info.func = function() xBagPerDB.Options.FilterPickupBank = not xBagPerDB.Options.FilterPickupBank end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Always Show Junk Icon"]
Info.checked = xBagPerDB.Options.ShowJunk
Info.func = function()
xBagPerDB.Options.ShowJunk = not xBagPerDB.Options.ShowJunk
local First, Last
for BagIndex = 0, NUM_BAG_SLOTS do
local BagID = IsBagOpen(BagIndex)
if (BagID) then
First, Last = 1, GetContainerNumSlots(BagIndex)
for SlotIndex = First, Last do
local ContainerIndex = Last - SlotIndex + 1
if (BagIndex == 0 and Last == 16) then ContainerIndex = ContainerIndex + 4; end
local Slot = _G["ContainerFrame"..BagID.."Item"..ContainerIndex]
Slot.JunkIcon:Hide()
if (xBagPerDB.Options.ShowJunk) then
local _, _, _, Quality, Readable, Lootable, _, _, _, itemID1 = GetContainerItemInfo(BagIndex, SlotIndex)
if (itemID1 and Quality == Enum.ItemQuality.Poor) then Slot.JunkIcon:Show(); end
end
end
end
end
end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Show Bag Names"]
Info.checked = xBagPerDB.Options.ShowBagName
Info.func = function()
xBagPerDB.Options.ShowBagName = not xBagPerDB.Options.ShowBagName
for i = 1, xBag.Data.MaxBags do
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Name:SetShown(xBagPerDB.Options.ShowBagName)
xBag.Frames.BankBag[0].BagSelectionButton[i].Name:SetShown(xBagPerDB.Options.ShowBagName)
end
end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Hide Empty Bags"].."   |cffffe00a("..L["recommended"]..")"
Info.checked = xBagPerDB.Options.HideEmptyBags
Info.func = function()
xBagPerDB.Options.HideEmptyBags = not xBagPerDB.Options.HideEmptyBags
if (xBagPerDB.Options.HideEmptyBags) then
for i = 1, xBag.Data.MaxBags do
if (#xBag.Data.BagList[i] == 0 and xBag.Frames.ExtraBag[i]:IsShown()) then xBag.Frames.ExtraBag[i]:Hide(); end
if (#xBag.Data.BankBagList[i] == 0 and xBag.Frames.BankBag[i]:IsShown()) then xBag.Frames.BankBag[i]:Hide(); end
end
end
end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Wait To Resize Active Bag"]
Info.checked = xBagPerDB.Options.NoResize
Info.func = function() xBagPerDB.Options.NoResize = not xBagPerDB.Options.NoResize end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Remove Always Show When Filter Changes"]
Info.checked = xBagPerDB.Options.RemoveShow
Info.func = function() xBagPerDB.Options.RemoveShow = not xBagPerDB.Options.RemoveShow end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Ignore Always Show"]
Info.checked = xBagPerDB.Options.IgnoreShow
Info.func = function() xBagPerDB.Options.IgnoreShow = not xBagPerDB.Options.IgnoreShow end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Remember New Items"]
Info.checked = xBagPerDB.Options.RememberNew
Info.func = function()
xBagPerDB.Options.RememberNew = not xBagPerDB.Options.RememberNew
if (not xBagPerDB.Options.RememberNew) then xBag.Data.NewItems = nil; end
end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Show Item Level"]
Info.checked = xBagPerDB.Options.ShowIlvl
Info.func = function()
xBagPerDB.Options.ShowIlvl = not xBagPerDB.Options.ShowIlvl
xBag.Functions.RefreshBags(false)
if (xBag.Frames.BankBag[0]:IsShown()) then xBag.Functions.RefreshBags(true); end
end
UIDropDownMenu_AddButton(Info, Level)
wipe(Info)
Info.isTitle = true
Info.notCheckable = true
UIDropDownMenu_AddButton(Info, Level)
wipe(Info)
Info.notCheckable = true
Info.keepShownOnClick = true
Info.hasArrow = true
Info.colorCode = "|cff69ccf0"
Info.text = L["Open With"]
Info.value = "Open"
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Close With"]
Info.value = "Close"
UIDropDownMenu_AddButton(Info, Level)
Info.colorCode = "|cff9370DB"
Info.text = L["Open When Looting"]
Info.value = "Loot"
UIDropDownMenu_AddButton(Info, Level)
elseif (Level == 2) then
wipe(Info)
Info.keepShownOnClick = true
if (UIDROPDOWNMENU_MENU_VALUE == "Open") then
Info.colorCode = "|cff50C878"
Info.text = L["Bank"]
Info.checked = xBagPerDB.Options.OpenBank
Info.func = function() xBagPerDB.Options.OpenBank = not xBagPerDB.Options.OpenBank end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Merchant"]
Info.checked = xBagPerDB.Options.OpenMerchant
Info.func = function() xBagPerDB.Options.OpenMerchant = not xBagPerDB.Options.OpenMerchant end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Mailbox"]
Info.checked = xBagPerDB.Options.OpenMail
Info.func = function() xBagPerDB.Options.OpenMail = not xBagPerDB.Options.OpenMail end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Auction House"]
Info.checked = xBagPerDB.Options.OpenAuction
Info.func = function() xBagPerDB.Options.OpenAuction = not xBagPerDB.Options.OpenAuction end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Guild Bank"]
Info.checked = xBagPerDB.Options.OpenGuildBank
Info.func = function() xBagPerDB.Options.OpenGuildBank = not xBagPerDB.Options.OpenGuildBank end
UIDropDownMenu_AddButton(Info, Level)
elseif (UIDROPDOWNMENU_MENU_VALUE == "Close") then
Info.colorCode = "|cffD2042D"
Info.text = L["Bank"]
Info.checked = xBagPerDB.Options.CloseBank
Info.func = function() xBagPerDB.Options.CloseBank = not xBagPerDB.Options.CloseBank end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Merchant"]
Info.checked = xBagPerDB.Options.CloseMerchant
Info.func = function() xBagPerDB.Options.CloseMerchant = not xBagPerDB.Options.CloseMerchant end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Mailbox"]
Info.checked = xBagPerDB.Options.CloseMail
Info.func = function() xBagPerDB.Options.CloseMail = not xBagPerDB.Options.CloseMail end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Auction House"]
Info.checked = xBagPerDB.Options.CloseAuction
Info.func = function() xBagPerDB.Options.CloseAuction = not xBagPerDB.Options.CloseAuction end
UIDropDownMenu_AddButton(Info, Level)
Info.text = L["Guild Bank"]
Info.checked = xBagPerDB.Options.CloseGuildBank
Info.func = function() xBagPerDB.Options.CloseGuildBank = not xBagPerDB.Options.CloseGuildBank end
UIDropDownMenu_AddButton(Info, Level)
elseif (UIDROPDOWNMENU_MENU_VALUE == "Loot") then
local Text = {L["Always"], L["Never"], L["Only If Always Show"]}
Info.colorCode = "|cff50C878"
for i = 1, 3 do
Info.text = Text[i]
Info.checked = xBagPerDB.Options.LootOpen == i
Info.func = function()
xBagPerDB.Options.LootOpen = i
for x = 1, 3 do _G["DropDownList2Button"..x.."Check"]:SetShown(i == x) end
xBag.Data.LootID = nil
if (i ~= 2) then
xBag.Data.LootID = {}
xBag.Frames.Event:RegisterEvent("CHAT_MSG_LOOT")
else
xBag.Frames.Event:UnregisterEvent("CHAT_MSG_LOOT")
end
end
UIDropDownMenu_AddButton(Info, Level)
end
end
end
end
function xBag.Functions.InitUIBagButtonMenu(Self, Level)
if (not Self.xIndex) then return; end
local BagID = Self.xIndex
Level = Level or 1
local Info = UIDropDownMenu_CreateInfo()
if (Level == 1) then
local IndexList, Valid = {}
for i = 1, xBag.Data.MaxBags do
Valid = true
for x = 1, 5 do
if (i == xBagPerDB.UIBagButton[x]) then
Valid = false
break
end
end
if (Valid) then table.insert(IndexList, i); end
end
Info.notCheckable = true
Info.fontObject = "GameFontNormal"
for i = 1, #IndexList do
Info.text = "  "..IndexList[i]
Info.func = function()
local ID = IndexList[i]
xBagPerDB.UIBagButton[BagID] = ID
xBag.Frames.UIBagButton[BagID].Index:SetText(ID)
xBag.Frames.UIBagButton[BagID].Disabled:SetShown(not xBagPerDB.BagList[ID].Filter)
if (xBag.Frames.ExtraBag[xBagPerDB.UIBagButton[BagID]]:IsShown()) then xBag.Frames.UIBagButton[BagID]:SetButtonState("PUSHED", true); else xBag.Frames.UIBagButton[BagID]:SetButtonState("NORMAL", false); end
end
UIDropDownMenu_AddButton(Info, Level)
end
end
end
function xBag.Functions.RenameBag(isBank, BagID)
xBag.Frames.RenameBag:Hide()
local Parent
if (isBank) then Parent = xBag.Frames.BankBag[BagID]; else Parent = xBag.Frames.ExtraBag[BagID]; end
xBag.Frames.RenameBag.xOpened = true
xBag.Frames.RenameBag.xisBank = isBank
xBag.Frames.RenameBag.xBagID = BagID
xBag.Frames.RenameBag:ClearAllPoints()
xBag.Frames.RenameBag:SetPoint("CENTER", Parent.Header, "CENTER", 3, 0)
xBag.Frames.RenameBag:SetFrameStrata(Parent:GetFrameStrata())
xBag.Frames.RenameBag:SetFrameLevel(Parent:GetFrameLevel() + 1)
xBag.Frames.RenameBag:Show()
end
function xBag.Functions.AddCustom(isBank, BagID, ItemID)
if (isBank ~= xBag.Data.SlotPickup.isBank or xBag.Data.SlotPickup.isReagent or xBag.Data.SlotPickup.isInventory) then return; end
local CustomList
if (isBank) then CustomList = xBagPerDB.BankCustomList; else CustomList = xBagPerDB.BagCustomList; end
for i = 1, #CustomList[BagID] do if (CustomList[BagID][i] == ItemID) then return; end end
for i = 1, xBag.Data.MaxBags do
if (i ~= BagID) then
for x = 1, #CustomList[i] do if (CustomList[i][x] == ItemID) then table.remove(CustomList[i], x); end end
end
end
table.insert(CustomList[BagID], ItemID)
xBag.Functions.RefreshBags(isBank)
if (xBagPerDB.Options.HideEmptyBags) then
local BagList, Bag, DataBagList
if (isBank) then BagList, Bag, DataBagList = xBagPerDB.BankBagList, xBag.Frames.BankBag, xBag.Data.BankBagList; else BagList, Bag, DataBagList = xBagPerDB.BagList, xBag.Frames.ExtraBag, xBag.Data.BagList; end
for i = 1, xBag.Data.MaxBags do
if (BagList[i].Filter == 1 and #CustomList[i] == 0 and Bag[i]:IsShown()) then Bag[i]:Hide(); end
if (#DataBagList[i] == 0 and Bag[i]:IsShown()) then Bag[i]:Hide(); end
end
end
end
function xBag.Functions.FilterBags(isBank)
local SlotData, DisplayList, NewList, BagList, CustomList, First, Last, Min, Max, MaxFilters = {}, {}, {}
if (isBank) then
for i = 1, GetContainerNumSlots(-1) do
local Slot = _G["BankFrameItem"..i]
Slot:Hide()
table.insert(SlotData, {["Slot"] = Slot, ["BagIndex"] = -1, ["SlotIndex"] = i})
end
Min, Max, BagList, CustomList, MaxFilters = NUM_BAG_SLOTS + 1, NUM_BAG_SLOTS + NUM_BANKBAGSLOTS, xBag.Data.BankBagList, xBagPerDB.BankCustomList, xBag.Data.MaxBankFilters
else
Min, Max, BagList, CustomList, MaxFilters = 0, NUM_BAG_SLOTS, xBag.Data.BagList, xBagPerDB.BagCustomList, xBag.Data.MaxFilters
end
for BagIndex = Min, Max do
local BagID = IsBagOpen(BagIndex)
if (BagID) then
First, Last = 1, GetContainerNumSlots(BagIndex)
for SlotIndex = First, Last do
local ContainerIndex = Last - SlotIndex + 1
if ((not isBank) and BagIndex == 0 and Last == 16) then ContainerIndex = ContainerIndex + 4; end
local Slot = _G["ContainerFrame"..BagID.."Item"..ContainerIndex]
Slot:Hide()
table.insert(SlotData, {["Slot"] = Slot, ["BagIndex"] = BagIndex, ["SlotIndex"] = SlotIndex})
if (isBank) then
if (xBag.Data.NewFilter) then
if (C_NewItems.IsNewItem(BagIndex, SlotIndex)) then xBag.Functions.ClearNewItems(false, BagIndex, SlotIndex); end
end
end
end
end
end
for i = 1, MaxFilters + 1 do DisplayList[i] = {} end
for i = 1, xBag.Data.MaxBags do
if (#CustomList[i] > 0) then
for x = 1, #CustomList[i] do
for k, v in pairs(SlotData) do
if (v.Slot) then
local ItemID = GetContainerItemID(v.BagIndex, v.SlotIndex)
if (ItemID and CustomList[i][x] == ItemID) then
table.insert(BagList[i], v.Slot)
v.Slot = nil
if (xBag.Data.NewFilter) then
if (C_NewItems.IsNewItem(v.BagIndex, v.SlotIndex)) then xBag.Functions.ClearNewItems(false, v.BagIndex, v.SlotIndex); end
end
end
end
end
end
end
end
for _, v in pairs(SlotData) do
if (v.Slot) then
local _, Count, _, Quality, Readable, Lootable, _, _, _, itemID1 = GetContainerItemInfo(v.BagIndex, v.SlotIndex)
local itemID2, itemEquipLoc, ClassID, SubClassID
if (itemID1) then itemID2, _, _, itemEquipLoc, _, ClassID, SubClassID = GetItemInfoInstant(itemID1); end
if (itemID2) then
if (xBag.Functions.FilterNew(v.BagIndex, v.SlotIndex, itemID2, Count, v.Slot, Quality)) then
table.insert(DisplayList[19], v.Slot)
table.insert(NewList, {itemID2, Count})
elseif (xBag.Functions.FilterCraftingReagent(ClassID)) then
table.insert(DisplayList[2], v.Slot)
elseif (xBag.Functions.FilterReagent(ClassID, SubClassID)) then
table.insert(DisplayList[3], v.Slot)
elseif (xBag.Functions.FilterChest(Lootable)) then
table.insert(DisplayList[4], v.Slot)
elseif (xBag.Functions.FilterGearBags(itemEquipLoc, v.BagIndex, v.SlotIndex, true)) then
table.insert(DisplayList[5], v.Slot)
elseif (xBag.Functions.FilterGearBags(itemEquipLoc, v.BagIndex, v.SlotIndex, false)) then
table.insert(DisplayList[6], v.Slot)
elseif (xBag.Functions.FilterMountPetToy(ClassID, SubClassID, itemID2)) then
table.insert(DisplayList[7], v.Slot)
elseif (xBag.Functions.FilterAnimaRelics(ClassID, SubClassID, itemID2, xBag.Data.Anima)) then
table.insert(DisplayList[8], v.Slot)
elseif (xBag.Functions.FilterAnimaRelics(ClassID, SubClassID, itemID2, xBag.Data.KorthianRelic)) then
table.insert(DisplayList[9], v.Slot)
elseif (xBag.Functions.FilterKeys(ClassID)) then
table.insert(DisplayList[10], v.Slot)
elseif (xBag.Functions.FilterRecipe(ClassID)) then
table.insert(DisplayList[11], v.Slot)
elseif (xBag.Functions.FilterEnhancement(ClassID)) then
table.insert(DisplayList[12], v.Slot)
elseif (xBag.Functions.FilterConsumable(ClassID, SubClassID, true)) then
table.insert(DisplayList[13], v.Slot)
elseif (xBag.Functions.FilterConsumable(ClassID, SubClassID, false)) then
table.insert(DisplayList[14], v.Slot)
elseif (xBag.Functions.FilterQuest(ClassID)) then
table.insert(DisplayList[15], v.Slot)
elseif (xBag.Functions.FilterReadable(Readable)) then
table.insert(DisplayList[16], v.Slot)
elseif (xBag.Functions.FilterJunk(Quality)) then
table.insert(DisplayList[17], v.Slot)
else
table.insert(DisplayList[18], v.Slot)
end
else
table.insert(DisplayList[MaxFilters + 1], v.Slot)
end
end
end
for i = 1, MaxFilters + 1 do
local BagID = xBag.Functions.FilterCheck(i, isBank) or 0
for x = 1, #DisplayList[i] do table.insert(BagList[BagID], DisplayList[i][x]) end
end
if (not isBank) then
if (xBag.Data.NewItems) then
xBag.Data.NewItems = nil
if (#NewList > 0) then
xBag.Data.NewItems = {}
for i = 1, #NewList do table.insert(xBag.Data.NewItems, NewList[i]) end
end
end
xBag.Functions.AddNewItems()
end
end
function xBag.Functions.FilterCheck(Filter, isBank)
local BagList
if (isBank) then BagList = xBagPerDB.BankBagList; else BagList = xBagPerDB.BagList; end
for i = 1, xBag.Data.MaxBags do if (BagList[i].Filter == Filter) then return i; end end
end
function xBag.Functions.FilterCraftingReagent(ClassID) return ClassID == LE_ITEM_CLASS_TRADEGOODS end
function xBag.Functions.FilterReagent(ClassID, SubClassID) return ClassID == LE_ITEM_CLASS_MISCELLANEOUS and SubClassID == LE_ITEM_MISCELLANEOUS_REAGENT end
function xBag.Functions.FilterChest(Lootable) return Lootable end
function xBag.Functions.FilterGearBags(Location, BagID, SlotID, Bound)
if (Location == "") then return false; end
local Item = ItemLocation:CreateFromBagAndSlot(BagID, SlotID)
if (Bound) then return C_Item.IsBound(Item); else return not C_Item.IsBound(Item); end
end
function xBag.Functions.FilterMountPetToy(ClassID, SubClassID, ItemID)
if (ClassID ~= LE_ITEM_CLASS_MISCELLANEOUS) then return false; end
local isToy
if (SubClassID == LE_ITEM_MISCELLANEOUS_OTHER) then
xBag.Frames.ScanTip:ClearLines()
xBag.Frames.ScanTip:SetItemByID(ItemID)
for i = 1, xBag.Frames.ScanTip:NumLines() do
if (_G["xBagScanTipTextLeft"..i]:GetText() == xBag.Data.Toy) then
isToy = true
break
end
end
end
return (SubClassID == LE_ITEM_MISCELLANEOUS_COMPANION_PET or SubClassID == LE_ITEM_MISCELLANEOUS_MOUNT or SubClassID == LE_ITEM_MISCELLANEOUS_MOUNT_EQUIPMENT) or (SubClassID == LE_ITEM_MISCELLANEOUS_OTHER and isToy)
end
function xBag.Functions.FilterAnimaRelics(ClassID, SubClassID, ItemID, Item)
if (not (ClassID == LE_ITEM_CLASS_MISCELLANEOUS and SubClassID == LE_ITEM_MISCELLANEOUS_OTHER)) then return false; end
if (Item == xBag.Data.KorthianRelic and (ItemID == 187478 or ItemID == 187503)) then return true; end
xBag.Frames.ScanTip:ClearLines()
xBag.Frames.ScanTip:SetItemByID(ItemID)
return _G["xBagScanTipTextLeft2"]:GetText() == Item
end
function xBag.Functions.FilterKeys(ClassID) return ClassID == LE_ITEM_CLASS_KEY end
function xBag.Functions.FilterRecipe(ClassID) return ClassID == LE_ITEM_CLASS_RECIPE end
function xBag.Functions.FilterEnhancement(ClassID) return ClassID == LE_ITEM_CLASS_GEM or ClassID == LE_ITEM_CLASS_ITEM_ENHANCEMENT or ClassID == LE_ITEM_CLASS_GLYPH end
function xBag.Functions.FilterConsumable(ClassID, SubClassID, Usable)
if (Usable) then return ClassID == LE_ITEM_CLASS_CONSUMABLE and (SubClassID == 1 or SubClassID == 2 or SubClassID == 3 or SubClassID == 5 or SubClassID == 7); else return ClassID == LE_ITEM_CLASS_CONSUMABLE and not (SubClassID == 1 or SubClassID == 2 or SubClassID == 3 or SubClassID == 5 or SubClassID == 7); end
end
function xBag.Functions.FilterQuest(ClassID) return ClassID == LE_ITEM_CLASS_QUESTITEM end
function xBag.Functions.FilterReadable(Readable) return Readable end
function xBag.Functions.FilterJunk(Quality) return (Quality == Enum.ItemQuality.Poor) end
function xBag.Functions.FilterNew(BagID, SlotID, ItemID, Count, Slot, Quality)
if (xBag.Data.NewItems) then
for _, v in pairs(xBag.Data.NewItems) do
if (v[1] == ItemID and v[2] == Count) then
C_Timer.After(0, function()
if (IsBattlePayItem(BagID, SlotID)) then
Slot.NewItemTexture:Hide()
Slot.BattlepayItemTexture:Show()
else
if (Quality and NEW_ITEM_ATLAS_BY_QUALITY[Quality]) then Slot.NewItemTexture:SetAtlas(NEW_ITEM_ATLAS_BY_QUALITY[Quality]); else Slot.NewItemTexture:SetAtlas("bags-glow-white"); end
Slot.BattlepayItemTexture:Hide()
Slot.NewItemTexture:Show()
end
if (not Slot.flashAnim:IsPlaying() and not Slot.newitemglowAnim:IsPlaying()) then
Slot.flashAnim:Play()
Slot.newitemglowAnim:Play()
end
end)
return true
end
end
end
return C_NewItems.IsNewItem(BagID, SlotID) and xBag.Data.NewFilter
end
end
function xBag.Functions.CreateHooks()
xBag.Frames.UIBagButton = {}
MainMenuBarBackpackButton:Hide()
MainMenuBarBackpackButton:SetScript("OnClick", nil)
MainMenuBarBackpackButton:SetScript("OnDragStart", nil)
MainMenuBarBackpackButton:SetScript("OnReceiveDrag", ClearCursor)
xBag.Frames.UIBagButton[0] = CreateFrame("Button", "xBagUIBagButton0", MicroButtonAndBagsBar)
xBag.Frames.UIBagButton[0]:SetAllPoints(MainMenuBarBackpackButton)
local BagIndex, UIIndex = 0, 5
for i = 0, 3 do
local Bag = _G["CharacterBag"..BagIndex.."Slot"]
Bag:Hide()
Bag:SetScript("OnClick", nil)
Bag:SetScript("OnDragStart", nil)
Bag:SetScript("OnReceiveDrag", ClearCursor)
xBag.Frames.UIBagButton[UIIndex] = CreateFrame("Button", "xBagUIBagButton"..UIIndex, MicroButtonAndBagsBar)
xBag.Frames.UIBagButton[UIIndex]:SetID(5 - i)
xBag.Frames.UIBagButton[UIIndex]:SetAllPoints(Bag)
if (i == 3) then
xBag.Frames.UIBagButton[1] = CreateFrame("Button", "xBagUIBagButton1", MicroButtonAndBagsBar)
xBag.Frames.UIBagButton[1]:SetID(1)
xBag.Frames.UIBagButton[1]:SetSize(Bag:GetWidth(), Bag:GetHeight())
xBag.Frames.UIBagButton[1]:SetPoint("RIGHT", Bag, "LEFT", -1.9999998807907, 0)
end
BagIndex, UIIndex = BagIndex + 1, UIIndex - 1
end
for i = 0, 5 do
local Bag = xBag.Frames.UIBagButton[i]
Bag:RegisterForClicks("AnyUp")
Bag:SetNormalTexture("Interface\\Addons\\xBag\\Images\\icons")
Bag:SetHighlightTexture("Interface\\Addons\\xBag\\Images\\icons")
Bag:SetPushedTexture("Interface\\Addons\\xBag\\Images\\icons")
Bag:GetNormalTexture():SetTexCoord(0, 0.25, 0, 0.5)
Bag:GetHighlightTexture():SetTexCoord(0.25, 0.5, 0, 0.5)
Bag:GetPushedTexture():SetTexCoord(0.5, 0.75, 0, 0.5)
if (i > 0) then
local ID = xBagPerDB.UIBagButton[i]
Bag.Index = Bag:CreateFontString(nil, "OVERLAY")
Bag.Index:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
Bag.Index:SetFontObject("NumberFontNormal")
Bag.Index:SetPoint("TOPLEFT", 2, -4)
Bag.Index:SetTextColor(1, 0.88, 0.04, 1)
Bag.Index:SetText(ID)
Bag.Disabled = CreateFrame("Frame", nil, Bag, BackdropTemplateMixin and "BackdropTemplate")
Bag.Disabled:SetSize(20, 20)
Bag.Disabled:SetPoint("BOTTOMRIGHT")
Bag.Disabled:SetBackdrop({bgFile = "Interface\\BUTTONS\\UI-GROUPLOOT-PASS-DOWN"})
Bag:SetScript("OnEnter", function(Self)
local ID = xBagPerDB.UIBagButton[i]
if (xBagPerDB.BagList[ID].Name) then
GameTooltip:SetOwner(Self, "ANCHOR_TOP")
GameTooltip:SetText(xBagPerDB.BagList[ID].Name, nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end
end)
Bag:SetScript("OnLeave", function() GameTooltip_Hide() end)
end
if (i == 0) then
Bag:SetScript("OnClick", function(Self, Button)
if (Button == "LeftButton") then xBag.Functions.ToggleBag(); elseif (Button == "RightButton") then xBag.Functions.ToggleAll(false); end                
end)
else
Bag:SetScript("OnClick", function(Self, Button)
if (Button == "LeftButton") then
xBag.Functions.UIBagButtonClick(Self)
elseif (Button == "RightButton") then
xBag.Frames.UIBagButtonMenu.xIndex = i
UIDropDownMenu_SetAnchor(xBag.Frames.UIBagButtonMenu, 0, 3, "BOTTOM", Self, "TOP") 
ToggleDropDownMenu(1, nil, xBag.Frames.UIBagButtonMenu, Self, 0, 0)
end
end)
end
end
local UIBagButtonBackground = MicroButtonAndBagsBar:CreateTexture(nil, "BACKGROUND")
UIBagButtonBackground:SetTexture("Interface\\Addons\\xBag\\Images\\icons")
UIBagButtonBackground:SetTexCoord(0.75, 1, 0, 0.5)
UIBagButtonBackground:SetSize(35, 35)
UIBagButtonBackground:SetPoint("CENTER", xBag.Frames.UIBagButton[1], "CENTER", 0, 0)
MainMenuBarBackpackButtonCount:ClearAllPoints()
MainMenuBarBackpackButtonCount:SetParent(xBag.Frames.UIBagButton[0])
MainMenuBarBackpackButtonCount:SetPoint("CENTER", 0, -10)
function ToggleBag(id) end
function ToggleBackpack() end
function OpenAllBags(frame, forceUpdate) end
function ToggleAllBags() xBag.Functions.ToggleBag() end
function UpdateContainerFrameAnchors() end
LootFrame:HookScript("OnShow", function(Self)
if (Self:GetFrameStrata() ~= "DIALOG" or Self:GetFrameLevel() ~= 2000) then
Self:SetFrameStrata("DIALOG")
Self:SetFrameLevel(2000)
end
end)
StackSplitFrame:HookScript("OnShow", function(Self)
if (Self:GetFrameStrata() ~= "DIALOG" or Self:GetFrameLevel() ~= 2000) then
Self:SetFrameStrata("DIALOG")
Self:SetFrameLevel(2000)
end
end)
function ContainerFrame_GenerateFrame(frame, size, id)
local MAX_CONTAINER_ITEMS = 36
frame.size = size
local name = frame:GetName()
if (size > 1) then
local index, itemButton
for i=1, size, 1 do
index = size - i + 1
itemButton = _G[name.."Item"..i]
itemButton:SetID(index);
itemButton:ClearAllPoints()
itemButton:Hide()
itemButton:SetIgnoreParentAlpha(true)
if (not itemButton.xLvl) then
itemButton.xLvl = itemButton:CreateFontString(nil, "ARTWORK")
itemButton.xLvl:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
itemButton.xLvl:SetFontObject("GameTooltipText")
itemButton.xLvl:SetTextColor(1, 0.988, 0, 1)
itemButton.xLvl:SetPoint("TOPLEFT", 2, -3)
itemButton.xLvl:Hide()
end
end
end
for i=size + 1, MAX_CONTAINER_ITEMS, 1 do _G[name.."Item"..i]:Hide() end
frame:SetID(id)
frame:SetSize(0, 0)
frame:SetAlpha(0)
frame:Show()
frame:Raise()
if (id > NUM_BAG_SLOTS) then frame:SetFrameStrata("HIGH"); else frame:SetFrameStrata("DIALOG"); end
if (ContainerFrame1MoneyFrame:GetParent() ~= xBag.Frames.ExtraBag[0].Money) then
ContainerFrame1MoneyFrame:ClearAllPoints()
ContainerFrame1MoneyFrame:SetParent(xBag.Frames.ExtraBag[0].Money)
ContainerFrame1MoneyFrame:SetPoint("RIGHT", 10, -2)
end
end
function ContainerFrame_Update(self)
local CONTAINER_HELPTIP_SYSTEM = "ContainerFrame"
local id = self:GetID();
local name = self:GetName();
local itemButton;
local texture, itemCount, locked, quality, readable, itemLink, isFiltered, noValue, itemID, isBound, _;
local isQuestItem, questId, isActive, questTexture;
local battlepayItemTexture, newItemTexture, flash, newItemAnim;
local tooltipOwner = GameTooltip:GetOwner();
local baseSize = GetContainerNumSlots(id);	
self.FilterIcon:Hide();
if ( id ~= 0 and not IsInventoryItemProfessionBag("player", ContainerIDToInventoryID(id)) ) then
for i = LE_BAG_FILTER_FLAG_EQUIPMENT, NUM_LE_BAG_FILTER_FLAGS do
local active = false;
if ( id > NUM_BAG_SLOTS ) then
active = GetBankBagSlotFlag(id - NUM_BAG_SLOTS, i);
else
active = GetBagSlotFlag(id, i);
end
if ( active ) then
self.FilterIcon.Icon:SetAtlas(BAG_FILTER_ICONS[i], true);
self.FilterIcon:Show();
break;
end
end
end
if ( id == 0 ) then
BagItemSearchBox:ClearAllPoints()
BagItemSearchBox:SetParent(xBag.Frames.ExtraBag[0])
BagItemSearchBox:SetWidth(150)
BagItemSearchBox:SetPoint("LEFT", xBag.Frames.ExtraBag[0].Sort, "RIGHT", 20, 0)
BagItemSearchBox.anchorBag = self;
BagItemSearchBox:Show()
BagItemAutoSortButton:Hide()
ContainerFrame1MoneyFrame:Show()
elseif ( BagItemSearchBox.anchorBag == self ) then
BagItemSearchBox:ClearAllPoints();
BagItemSearchBox:Hide();
BagItemSearchBox.anchorBag = nil;
BagItemAutoSortButton:ClearAllPoints();
BagItemAutoSortButton:Hide();
end
ContainerFrame_CloseTutorial(self);
local shouldDoAzeriteChecks = not Kiosk.IsEnabled() and not GetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_AZERITE_ITEM_IN_SLOT) and not ContainerFrame_IsTutorialShown();
for i=1, self.size, 1 do
itemButton = _G[name.."Item"..i];
texture, itemCount, locked, quality, readable, _, itemLink, isFiltered, noValue, itemID, isBound = GetContainerItemInfo(id, itemButton:GetID());
isQuestItem, questId, isActive = GetContainerItemQuestInfo(id, itemButton:GetID());
SetItemButtonTexture(itemButton, texture);
local doNotSuppressOverlays = false;
SetItemButtonQuality(itemButton, quality, itemLink, doNotSuppressOverlays, isBound);
SetItemButtonCount(itemButton, itemCount);
SetItemButtonDesaturated(itemButton, locked);
ContainerFrameItemButton_SetForceExtended(itemButton, itemButton:GetID() > baseSize);
questTexture = _G[name.."Item"..i.."IconQuestTexture"];
if ( questId and not isActive ) then
questTexture:SetTexture(TEXTURE_ITEM_QUEST_BANG);
questTexture:Show();
elseif ( questId or isQuestItem ) then
questTexture:SetTexture(TEXTURE_ITEM_QUEST_BORDER);
questTexture:Show();		
else
questTexture:Hide();
end
local isNewItem = C_NewItems.IsNewItem(id, itemButton:GetID());
local isBattlePayItem = IsBattlePayItem(id, itemButton:GetID());
battlepayItemTexture = _G[name.."Item"..i].BattlepayItemTexture;
newItemTexture = _G[name.."Item"..i].NewItemTexture;
flash = _G[name.."Item"..i].flashAnim;
newItemAnim = _G[name.."Item"..i].newitemglowAnim;
if ( isNewItem ) then
if (isBattlePayItem) then
newItemTexture:Hide();
battlepayItemTexture:Show();
else
if (quality and NEW_ITEM_ATLAS_BY_QUALITY[quality]) then
newItemTexture:SetAtlas(NEW_ITEM_ATLAS_BY_QUALITY[quality]);
else
newItemTexture:SetAtlas("bags-glow-white");
end
battlepayItemTexture:Hide();
newItemTexture:Show();
end
if (not flash:IsPlaying() and not newItemAnim:IsPlaying()) then
flash:Play();
newItemAnim:Play();
end
else
battlepayItemTexture:Hide();
newItemTexture:Hide();
if (flash:IsPlaying() or newItemAnim:IsPlaying()) then
flash:Stop();
newItemAnim:Stop();
end
end
itemButton.JunkIcon:Hide();
local itemLocation = ItemLocation:CreateFromBagAndSlot(self:GetID(), itemButton:GetID());
if C_Item.DoesItemExist(itemLocation) then
local isJunk = quality == Enum.ItemQuality.Poor and xBagPerDB.Options.ShowJunk and not noValue;
itemButton.JunkIcon:SetShown(isJunk);
end
itemButton:UpdateItemContextMatching();
ContainerFrameItemButton_UpdateItemUpgradeIcon(itemButton);
if ( texture ) then
ContainerFrame_UpdateCooldown(id, itemButton);
itemButton.hasItem = 1;
else
_G[name.."Item"..i.."Cooldown"]:Hide();
itemButton.hasItem = nil;
end
itemButton.readable = readable;
if ( itemButton == tooltipOwner ) then
if (GetContainerItemInfo(self:GetID(), itemButton:GetID())) then
itemButton.UpdateTooltip(itemButton);
else
GameTooltip:Hide();
end
end
itemButton:SetMatchesSearch(not isFiltered);
if ( not isFiltered ) then
if shouldDoAzeriteChecks then
shouldDoAzeriteChecks = ContainerFrame_ConsiderItemButtonForAzeriteTutorial(itemButton, itemID);
end
end
end
if id == 0 and IsAccountSecured() and not GetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_BAG_SLOTS_AUTHENTICATOR) and not ContainerFrame_IsTutorialShown() then
itemButton = _G[name.."Item"..4];
local helpTipInfo = {
text = BACKPACK_AUTHENTICATOR_EXTRA_SLOTS_ADDED,
buttonStyle = HelpTip.ButtonStyle.Close,
cvarBitfield = "closedInfoFrames",
bitfieldFlag = LE_FRAME_TUTORIAL_BAG_SLOTS_AUTHENTICATOR,
targetPoint = HelpTip.Point.LeftEdgeCenter,
offsetX = 1,
system = CONTAINER_HELPTIP_SYSTEM,
};
HelpTip:Show(UIParent, helpTipInfo, itemButton);
self.helpTipSystem = CONTAINER_HELPTIP_SYSTEM;
end
local bagButton = ContainerFrame_GetBagButton(self);
bagButton:UpdateItemContextMatching();
end
function ContainerFrame_ConsiderItemButtonForAzeriteTutorial(itemButton, itemID)
if itemID and C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItemByID(itemID) then
if AzeriteUtil.AreAnyAzeriteEmpoweredItemsEquipped() then
SetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_AZERITE_ITEM_IN_SLOT, true);
return false;
end
local helpTipInfo = {
text = AZERITE_TUTORIAL_ITEM_IN_SLOT,
buttonStyle = HelpTip.ButtonStyle.Close,
cvarBitfield = "closedInfoFrames",
bitfieldFlag = LE_FRAME_TUTORIAL_AZERITE_ITEM_IN_SLOT,
targetPoint = HelpTip.Point.LeftEdgeCenter,
offsetX = -3,
system = CONTAINER_HELPTIP_SYSTEM,
};
HelpTip:Show(UIParent, helpTipInfo, itemButton);
local containerFrame = itemButton:GetParent();
containerFrame.helpTipSystem = CONTAINER_HELPTIP_SYSTEM;
return false;
end
return true;
end
xBag.Functions.RemoveNewItem = C_NewItems.RemoveNewItem
hooksecurefunc("CloseDropDownMenus", function(level)
xBag.Frames.FilterMenu.xShown = not xBag.Frames.FilterMenu.xShown
xBag.Frames.BankFilterMenu.xShown = not xBag.Frames.BankFilterMenu.xShown
end)
hooksecurefunc("BankFrame_ShowPanel", function(self)
if (_G["BankFrameItem1"].xParent ~= BankSlotsFrame) then
for i = 1, GetContainerNumSlots(-1) do
local Slot = _G["BankFrameItem"..i]
Slot.xParent = BankSlotsFrame
Slot.GetParent = function() return BankSlotsFrame end
if (not Slot.xLvl) then
Slot.xLvl = Slot:CreateFontString(nil, "ARTWORK")
Slot.xLvl:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
Slot.xLvl:SetFontObject("GameTooltipText")
Slot.xLvl:SetTextColor(1, 0.988, 0, 1)
Slot.xLvl:SetPoint("TOPLEFT", 2, -3)
Slot.xLvl:Hide()
end
end
end
if (IsReagentBankUnlocked()) then
ReagentBankFrame:Show()
if (_G["ReagentBankFrameItem1"].xParent ~= ReagentBankFrame) then
local InitLeft, InitTop, ColSize = 0, 0, 14
local Left, Top = InitLeft, InitTop
local Index = 1
for i = 1, GetContainerNumSlots(-3) do
local Slot = _G["ReagentBankFrameItem"..i]
Slot.xParent = ReagentBankFrame
Slot.GetParent = function() return ReagentBankFrame end
Slot:ClearAllPoints()
Slot:SetParent(xBag.Frames.ReagentBag.Display)
Slot:SetPoint("TOPLEFT", Left, Top)
if (Index == ColSize) then Index, Left, Top = 1, InitLeft, Top - 37 - 5; else Index, Left = Index + 1, Left + 37 + 5; end
end
end
ReagentBankFrame:Hide()
end
BankFrame:SetAlpha(0)
BankFrame:SetSize(1, 1)
end)
hooksecurefunc("ClearCursor", function() xBag.Data.SlotPickup.BagID, xBag.Data.SlotPickup.SlotID, xBag.Data.SlotPickup.isBank, xBag.Data.SlotPickup.isReagent, xBag.Data.SlotPickup.isInventory = nil, nil, false, nil, nil end)
hooksecurefunc("PickupInventoryItem", function() xBag.Data.SlotPickup.isInventory = true end)
hooksecurefunc("PickupContainerItem", function(BagID, SlotID)
if (xBag.Data.NewFilter) then
local IsNewItem = C_NewItems.IsNewItem(BagID, SlotID)
if (not IsNewItem and xBag.Data.NewItems) then
local _, Count, _, _, _, _, _, _, _, ItemID = GetContainerItemInfo(BagID, SlotID)
for _, v in pairs(xBag.Data.NewItems) do
if (v[1] == ItemID and v[2] == Count) then
IsNewItem = true
break
end
end
end
if (IsNewItem) then xBag.Functions.ClearNewItems(false, BagID, SlotID); end
end
if (not xBag.Data.SlotPickup.BagID) then
if (CursorHasItem()) then xBag.Data.SlotPickup.BagID, xBag.Data.SlotPickup.SlotID, xBag.Data.SlotPickup.isBank, xBag.Data.SlotPickup.isReagent, xBag.Data.SlotPickup.isInventory = BagID, SlotID, (BagID > NUM_BAG_SLOTS) or BagID == -1, (BagID == -3), nil; end
else
local isBank = (BagID > NUM_BAG_SLOTS)
local itemLoc1, itemLoc2 = ItemLocation:CreateFromBagAndSlot(xBag.Data.SlotPickup.BagID, xBag.Data.SlotPickup.SlotID), ItemLocation:CreateFromBagAndSlot(BagID, SlotID)
local CustomList1, CustomList2
if (xBag.Data.SlotPickup.isBank) then CustomList1 = xBagPerDB.BankCustomList; else CustomList1 = xBagPerDB.BagCustomList; end
if (isBank) then CustomList2 = xBagPerDB.BankCustomList; else CustomList2 = xBagPerDB.BagCustomList; end
if (itemLoc1:IsValid() and itemLoc2:IsValid()) then
local ItemID1, ItemID2 = C_Item.GetItemID(itemLoc1), C_Item.GetItemID(itemLoc2)
local Swap1, Swap2 = {["BagID"] = nil, ["SlotID"] = nil}, {["BagID"] = nil, ["SlotID"] = nil}
for i = 1, xBag.Data.MaxBags do
for x = 1, #CustomList1[i] do
if (CustomList1[i][x] == ItemID1) then
Swap1.BagID, Swap1.SlotID = i, x
break
end
end
for x = 1, #CustomList2[i] do
if (CustomList2[i][x] == ItemID2) then
Swap2.BagID, Swap2.SlotID = i, x
break
end
end
if (Swap1.BagID and Swap2.BagID) then break; end
end
if (Swap1.BagID and Swap2.BagID) then
CustomList1[Swap1.BagID][Swap1.SlotID] = ItemID2
CustomList2[Swap2.BagID][Swap2.SlotID] = ItemID1
end
elseif (itemLoc1:IsValid()) then
local ItemID1 = C_Item.GetItemID(itemLoc1)
for i = 1, xBag.Data.MaxBags do
for x = 1, #CustomList1[i] do
if (CustomList1[i][x] == ItemID1) then
table.remove(CustomList1[i], x)
break
end
end
end
end
xBag.Data.SlotPickup.BagID, xBag.Data.SlotPickup.SlotID, xBag.Data.SlotPickup.isBank, xBag.Data.SlotPickup.isReagent, xBag.Data.SlotPickup.isInventory = nil, nil, (BagID > NUM_BAG_SLOTS) or BagID == -1, nil, nil
end
end)
hooksecurefunc("CloseBag", function(BagID)
if (BagID > NUM_BAG_SLOTS) then
if (xBag.Frames.BankBag[0]:IsShown()) then xBag.Frames.BankBag[0]:Hide(); end
if (xBag.Frames.ReagentBag:IsShown()) then xBag.Frames.ReagentBag:Hide(); end
else
if (xBag.Frames.ExtraBag[0]:IsShown()) then xBag.Frames.ExtraBag[0]:Hide(); end
end
end)
hooksecurefunc("DepositReagentBank", function()
local CustomList, UpdateBag, UpdateBank = {}
for i = 1, xBag.Data.MaxBags do
if (#xBagPerDB.BagCustomList[i] > 0) then
wipe(CustomList)
for x = 1, #xBagPerDB.BagCustomList[i] do if (select(6, GetItemInfoInstant(xBagPerDB.BagCustomList[i][x])) ~= LE_ITEM_CLASS_TRADEGOODS) then table.insert(CustomList, xBagPerDB.BagCustomList[i][x]); end end
wipe(xBagPerDB.BagCustomList[i])
for n = 1, #CustomList do table.insert(xBagPerDB.BagCustomList[i], CustomList[n]) end
UpdateBag = true
end
if (#xBagPerDB.BankCustomList[i] > 0) then
wipe(CustomList)
for x = 1, #xBagPerDB.BankCustomList[i] do if (select(6, GetItemInfoInstant(xBagPerDB.BankCustomList[i][x])) ~= LE_ITEM_CLASS_TRADEGOODS) then table.insert(CustomList, xBagPerDB.BankCustomList[i][x]); end end
wipe(xBagPerDB.BankCustomList[i])
for n = 1, #CustomList do table.insert(xBagPerDB.BankCustomList[i], CustomList[n]) end
UpdateBank = true
end
end
if (UpdateBag and (not xBagPerDB.Options.FilterPickupBag)) then xBag.Functions.RefreshBags(false); end
if (UpdateBank and (not xBagPerDB.Options.FilterPickupBank)) then xBag.Functions.RefreshBags(true); end
end)
end
function xBag.Functions.CreateFrames()
xBag.Frames.ScanTip = CreateFrame("GameTooltip", "xBagScanTip", nil, "GameTooltipTemplate")
xBag.Frames.ScanTip:SetOwner(UIParent, "ANCHOR_NONE")
xBag.Frames.GuideDisplay = CreateFrame("ScrollFrame", "xBagGuideDisplay", UIParent, "SecureHandlerBaseTemplate, InputScrollFrameTemplate")
tinsert(UISpecialFrames, "xBagGuideDisplay")
xBag.Frames.GuideDisplay:SetFrameStrata("TOOLTIP")
xBag.Frames.GuideDisplay:SetMovable(true)
xBag.Frames.GuideDisplay:RegisterForDrag("LeftButton")
xBag.Frames.GuideDisplay:SetSize(750, 880)
xBag.Frames.GuideDisplay:SetPoint("CENTER")
xBag.Frames.GuideDisplay.CharCount:Hide()
xBag.Frames.GuideDisplay.EditBox:SetSize(750, 1)
xBag.Frames.GuideDisplay.EditBox:SetFontObject("ChatFontNormal")
xBag.Frames.GuideDisplay.EditBox:SetFont("Fonts\\ARIALN.TTF", 16)
xBag.Frames.GuideDisplay.EditBox:EnableMouse(false)
xBag.Frames.GuideDisplay.EditBox:EnableKeyboard(false)
xBag.Frames.GuideDisplay.EditBox:Disable(true)
xBag.Frames.GuideDisplay.EditBox:SetText(xBag.Data.GuideData)
xBag.Frames.GuideDisplay.Close = CreateFrame("Button", nil, xBag.Frames.GuideDisplay, "UIPanelCloseButton")
xBag.Frames.GuideDisplay.Close:SetSize(40, 40)
xBag.Frames.GuideDisplay.Close:SetPoint("TopRight", 10, 37)
xBag.Frames.GuideDisplay:Hide()
xBag.Frames.GenericContainer = CreateFrame("Frame")
xBag.Frames.SlashHelp = CreateFrame("Cooldown", nil, xBag.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
xBag.Frames.SlashHelp:SetAttribute("_onshow", [=[
self:Hide()
self:GetFrameRef("xBagGuideDisplay"):Show()
]=])
xBag.Frames.SlashHelp:SetFrameRef("xBagGuideDisplay", xBag.Frames.GuideDisplay)
xBag.Frames.RenameBag = CreateFrame("EditBox", nil, UIParent, "InputBoxTemplate")
xBag.Frames.RenameBag:SetSize(110, 10)
xBag.Frames.RenameBag:SetMaxLetters(16)
xBag.Frames.RenameBag.Left:Hide()
xBag.Frames.RenameBag.Right:Hide()
xBag.Frames.RenameBag.Middle:Hide()
xBag.Frames.RenameBag:SetScript("OnShow", function(Self)
local Title
if (Self.xisBank) then Title = xBag.Frames.BankBag[Self.xBagID].Title; else Title = xBag.Frames.ExtraBag[Self.xBagID].Title; end
Title:Hide()
Self:SetText("")
end)
xBag.Frames.RenameBag:SetScript("OnHide", function(Self)
if (Self.xOpened) then
local Title
if (Self.xisBank) then Title = xBag.Frames.BankBag[Self.xBagID].Title; else Title = xBag.Frames.ExtraBag[Self.xBagID].Title; end
Title:Show()
Self.xOpened = nil
Self.xisBank = nil
Self.xBagID = nil
end
end)
xBag.Frames.RenameBag:SetScript("OnEscapePressed", function(Self) Self:Hide() end)
xBag.Frames.RenameBag:SetScript("OnEnterPressed", function(Self)
local Title, BagList, Label
if (Self.xisBank) then Title, BagList, Label = xBag.Frames.BankBag[Self.xBagID].Title, xBagPerDB.BankBagList[Self.xBagID], xBag.Frames.BankBag[0].BagSelectionButton[Self.xBagID].Name; else Title, BagList, Label = xBag.Frames.ExtraBag[Self.xBagID].Title, xBagPerDB.BagList[Self.xBagID], xBag.Frames.ExtraBag[0].BagSelectionButton[Self.xBagID].Name; end
local Name = Self:GetText()
if (Name and Name ~= "") then
BagList.Name = Name
xBag.Functions.SetBagTitleName(Title, Name)
xBag.Functions.SetBagName(Label, Name)
end
Self:Hide()
end)
xBag.Frames.RenameBag:Hide()
for i = 1, 5 do xBag.Frames.UIBagButton[i].Disabled:SetShown(not xBagPerDB.BagList[xBagPerDB.UIBagButton[i]].Filter) end
xBag.Frames.ExtraBag, xBag.Frames.ExtraBagHighlight = {}, {}
for i = 0, xBag.Data.MaxBags do
if (i == 0) then
xBag.Frames.ExtraBag[i] = CreateFrame("Frame", "xBagMain", UIParent, BackdropTemplateMixin and "BackdropTemplate")
xBag.Frames.ExtraBag[i]:SetSize(359.00003051758, 587.00067138672)
xBag.Data.MainBagWidth = xBag.Frames.ExtraBag[i]:GetWidth()
else
xBag.Frames.ExtraBagHighlight[i] = CreateFrame("Frame", nil, UIParent)
xBag.Frames.ExtraBagHighlight[i]:SetFrameStrata("DIALOG")
xBag.Frames.ExtraBagHighlight[i]:SetFrameLevel(999)
local Tex = xBag.Frames.ExtraBagHighlight[i]:CreateTexture(nil, "ARTWORK")
Tex:SetColorTexture(0.6, 0.19, 0.8, 1)
Tex:SetAllPoints()
xBag.Frames.ExtraBagHighlight[i]:Hide()
xBag.Frames.ExtraBag[i] = CreateFrame("Frame", "xBagBag"..i, UIParent, BackdropTemplateMixin and "BackdropTemplate")
xBag.Frames.ExtraBag[i]:SetWidth(195.00003051758)
xBag.Frames.ExtraBagHighlight[i]:SetAllPoints(xBag.Frames.ExtraBag[i])
xBag.Frames.ExtraBag[i].AlwaysShow = CreateFrame("CheckButton", nil, xBag.Frames.ExtraBag[i], "UICheckButtonTemplate")
xBag.Frames.ExtraBag[i].AlwaysShow:SetSize(25, 25)
xBag.Frames.ExtraBag[i].AlwaysShow:SetPoint("TOPLEFT", 8, -7)
xBag.Frames.ExtraBag[i].AlwaysShow:SetChecked(xBagPerDB.AlwaysShowBag[i])
xBag.Frames.ExtraBag[i].AlwaysShow:SetScript("OnClick", function(Self) xBagPerDB.AlwaysShowBag[i] = Self:GetChecked() end)
xBag.Frames.ExtraBag[i].AlwaysShow:SetScript("OnEnter", function(Self)
GameTooltip:SetOwner(Self, "ANCHOR_LEFT")
GameTooltip:SetText(L["Always Show"], nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end)
xBag.Frames.ExtraBag[i].AlwaysShow:SetScript("OnLeave", function() GameTooltip_Hide() end)
end
tinsert(UISpecialFrames, xBag.Frames.ExtraBag[i]:GetName())
xBag.Frames.ExtraBag[i]:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Rock", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", tile = false, insets = {left = 8, right = 8, top = 8, bottom = 8}, tileSize = 0, edgeSize = 24}
xBag.Frames.ExtraBag[i]:SetID(i)
xBag.Frames.ExtraBag[i]:EnableMouse(true)
xBag.Frames.ExtraBag[i]:SetFrameStrata("DIALOG")
xBag.Frames.ExtraBag[i]:SetFrameLevel(1000)
xBag.Frames.ExtraBag[i]:SetShown(false)
xBag.Frames.ExtraBag[i].Header = CreateFrame("Frame", nil, xBag.Frames.ExtraBag[i], BackdropTemplateMixin and "BackdropTemplate")
xBag.Frames.ExtraBag[i].Header:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Rock", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", tile = false, insets = {left = 8, right = 8, top = 8, bottom = 8}, tileSize = 0, edgeSize = 24}
xBag.Frames.ExtraBag[i].Header:SetSize(130, 37)
xBag.Frames.ExtraBag[i].Header:SetPoint("TOP", 0, 12)
xBag.Frames.ExtraBag[i].Title = xBag.Frames.ExtraBag[i].Header:CreateFontString(nil, "ARTWORK")
xBag.Frames.ExtraBag[i].Title:SetFontObject("GameFontNormal")
xBag.Frames.ExtraBag[i].Title:SetTextColor(0.41, 0.8, 0.94, 1)
xBag.Frames.ExtraBag[i].Title:SetPoint("CENTER")
xBag.Functions.SetBagTitleName(xBag.Frames.ExtraBag[i].Title, xBagPerDB.BagList[i].Name)
xBag.Frames.ExtraBag[i].Close = CreateFrame("Button", nil, xBag.Frames.ExtraBag[i], "UIPanelCloseButton")
xBag.Frames.ExtraBag[i].Close:SetSize(32, 32)
xBag.Frames.ExtraBag[i].Display = CreateFrame("Frame", nil, xBag.Frames.ExtraBag[i])
xBag.Frames.ExtraBag[i].Display:SetSize(1, 1)
xBag.Frames.ExtraBag[i]:SetScript("OnMouseWheel", function(Self, Delta) xBag.Functions.ListScroll(Self, Delta, false) end)
xBag.Frames.ExtraBag[i]:SetScript("OnShow", function(Self)
if (i == 0) then
if (xBag.Data.CloseCheck) then
xBag.Data.CloseCheck = false
for i = 1, xBag.Data.MaxBags do if (xBag.Frames.ExtraBag[i]:IsShown()) then xBag.Frames.ExtraBag[i]:Hide(); end end
end
xBag.Frames.UIBagButton[i]:SetButtonState("PUSHED", true)
for i = 0, xBag.Data.MaxBags do wipe(xBag.Data.BagList[i]) end
xBag.Functions.OpenCloseBags(false, true)
wipe(xBag.Data.ExtraBagsOpen)
if (xBagPerDB.Options.IgnoreShow) then
for i = 1, xBag.Data.MaxBags do if (xBag.Frames.ExtraBag[i]:IsShown()) then xBag.Frames.ExtraBag[i]:Hide(); end end
else
for i = 1, xBag.Data.MaxBags do xBag.Frames.ExtraBag[i]:SetShown(xBagPerDB.AlwaysShowBag[i] and (not xBagPerDB.Options.HideEmptyBags or (xBagPerDB.Options.HideEmptyBags and #xBag.Data.BagList[i] > 0))) end
end
else
for x = 1, 5 do
if (i == xBagPerDB.UIBagButton[x]) then
xBag.Frames.UIBagButton[x]:SetButtonState("PUSHED", true)
break
end
end
xBag.Functions.ResizeBag(i, false)
xBag.Functions.OpenExtraBag(i, false)
end
xBag.Functions.UpdateBags(false, i, xBag.Functions.GetBagIndex(i, false))
end)
xBag.Frames.ExtraBag[i]:SetScript("OnHide", function()
if (i == 0) then
xBag.Frames.UIBagButton[i]:SetButtonState("NORMAL", false)
for _, v in pairs (xBag.Data.ExtraBagsOpen) do xBag.Frames.ExtraBag[v]:Hide() end
xBag.Functions.OpenCloseBags(false, false)
else
if (xBag.Data.CloseCheck) then
local CloseBag = true
for i = 1, xBag.Data.MaxBags do
if (xBag.Frames.ExtraBag[i]:IsShown()) then
CloseBag = false
break
end
end
if (CloseBag) then xBag.Functions.OpenCloseBags(false, false); end
end
for x = 1, 5 do
if (i == xBagPerDB.UIBagButton[x]) then
xBag.Frames.UIBagButton[x]:SetButtonState("NORMAL", false)
break
end
end
xBag.Functions.CloseExtraBag(i, false)
if (xBag.Frames.RenameBag.xisBank == false) then xBag.Frames.RenameBag:Hide(); end
end
end)
if (i == 0) then
xBag.Frames.ExtraBag[i].Close:SetPoint("TOPRIGHT", -5, -5)
xBag.Frames.ExtraBag[i].Display:SetPoint("TOPLEFT", 13.999998092651, -27.999994277954)
else
xBag.Frames.ExtraBag[i].Close:SetPoint("TOPRIGHT", -3, -3)
xBag.Frames.ExtraBag[i].Display:SetPoint("TOPLEFT", 15, -34)
xBag.Frames.ExtraBag[i].Header:HookScript("OnMouseUp", function(Self, Button)
if (xBagPerDB.BagList[i].Filter == 1) then
xBag.Frames.ExtraBagHighlight[i]:Hide()
if (Button == "LeftButton") then
local ItemType, ItemID = GetCursorInfo()
if (ItemType == "item" and ItemID) then xBag.Functions.AddCustom(false, i, ItemID); end
elseif (Button == "RightButton") then
xBag.Functions.RenameBag(false, i)
end
elseif (xBagPerDB.BagList[i].Filter == 19) then
if (Button == "RightButton") then
xBag.Functions.ClearNewItems(true)
xBag.Functions.RefreshBags(false)
xBag.Frames.ExtraBag[i]:Hide()
end
end
ClearCursor()
end)
xBag.Frames.ExtraBag[i].Header:HookScript("OnReceiveDrag", function()
if (xBagPerDB.BagList[i].Filter == 1) then
xBag.Frames.ExtraBagHighlight[i]:Hide()
local ItemType, ItemID = GetCursorInfo()
if (ItemType == "item" and ItemID) then xBag.Functions.AddCustom(false, i, ItemID); end
end
ClearCursor()
end)
xBag.Frames.ExtraBag[i].Header:HookScript("OnEnter", function()
if (xBagPerDB.BagList[i].Filter == 1) then
local ItemType, ItemID = GetCursorInfo()
if (ItemType == "item" and ItemID) then xBag.Frames.ExtraBagHighlight[i]:Show(); end
end
end)
xBag.Frames.ExtraBag[i].Header:HookScript("OnLeave", function() xBag.Frames.ExtraBagHighlight[i]:Hide() end)
xBag.Frames.ExtraBag[i]:SetScript("OnLeave", function(Self)
if (Self.xResize) then
Self.xResize = nil
xBag.Functions.ResizeBag(i, false)
xBag.Functions.SetExtraBag(false)
end
end)
end
end
xBag.Frames.ExtraBag[0]:SetClampedToScreen(true)
xBag.Frames.ExtraBag[0]:SetClampRectInsets(-9, 0, 13, 0)
xBag.Frames.ExtraBag[0]:SetMovable(true)
xBag.Frames.ExtraBag[0]:RegisterForDrag("LeftButton")
xBag.Frames.ExtraBag[0]:SetAlpha(1)
if (xBagPerDB and xBagPerDB.MainBagPoints) then
xBag.Frames.ExtraBag[0]:SetPoint(xBagPerDB.MainBagPoints[1], xBagPerDB.MainBagPoints[2], xBagPerDB.MainBagPoints[3], xBagPerDB.MainBagPoints[4], xBagPerDB.MainBagPoints[5])
else
C_Timer.After(0, function()
local xPos = -9
if (MultiBarLeft:IsShown()) then xPos = xPos - MultiBarLeft:GetWidth(); end
if (MultiBarRight:IsShown()) then xPos = xPos - MultiBarRight:GetWidth(); end
xBag.Frames.ExtraBag[0]:SetPoint("BOTTOMRIGHT", xPos, 100)
end)
end
xBag.Frames.ExtraBag[0].Header:EnableMouse(true)
xBag.Frames.ExtraBag[0].Header:RegisterForDrag("LeftButton")
xBag.Frames.ExtraBag[0].Options = CreateFrame("DropDownToggleButton", nil, xBag.Frames.ExtraBag[0])
xBag.Frames.ExtraBag[0].Options:SetNormalTexture("Interface\\BUTTONS\\UI-OptionsButton")
xBag.Frames.ExtraBag[0].Options:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
xBag.Frames.ExtraBag[0].Options:SetSize(20, 20)
xBag.Frames.ExtraBag[0].Options:SetPoint("RIGHT", xBag.Frames.ExtraBag[0].Close, "LEFT", -5, 0)
xBag.Frames.ExtraBag[0].Options:SetScript("OnClick", function(Self) ToggleDropDownMenu(1, nil, xBag.Frames.OptionsMenu, Self, -7, 0) end)
xBag.Frames.ExtraBag[0].Options:SetScript("OnEnter", function(Self)
GameTooltip:SetOwner(Self, "ANCHOR_LEFT")
GameTooltip:SetText(L["Options"], nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end)
xBag.Frames.ExtraBag[0].Options:SetScript("OnLeave", function() GameTooltip_Hide() end)
xBag.Frames.ExtraBag[0].BagSelectionContainer = CreateFrame("Frame", nil, xBag.Frames.ExtraBag[0])
xBag.Frames.ExtraBag[0].BagSelectionContainer:SetSize(330, 37)
xBag.Frames.ExtraBag[0].BagSelectionContainer:SetPoint("TOPLEFT", 13, -64)
xBag.Frames.ExtraBag[0].BagSelectionContainer:SetScript("OnMouseWheel", function(Self, Delta) xBag.Functions.BagScroll(Delta, false) end)
xBag.Frames.ExtraBag[0].BagSelectionButton = {}
for i = 1, xBag.Data.MaxBags do
xBag.Frames.ExtraBag[0].BagSelectionButton[i] = CreateFrame("DropDownToggleButton", nil, xBag.Frames.ExtraBag[0].BagSelectionContainer)
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:RegisterForClicks("AnyUp")
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:RegisterForMouse("LeftButtonDown", "LeftButtonUp", "RightButtonDown", "RightButtonUp")
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetNormalTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetHighlightTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetPushedTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:GetNormalTexture():SetTexCoord(0, 0.25, 0, 0.5)
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:GetHighlightTexture():SetTexCoord(0.25, 0.5, 0, 0.5)
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:GetPushedTexture():SetTexCoord(0.5, 0.75, 0, 0.5)
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetSize(37, 37)
if (i == 1 or i == 6 or i == 11 or i == 16 or i == 21 or i == 26) then xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetPoint("LEFT", 8, 0); else xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetPoint("LEFT", xBag.Frames.ExtraBag[0].BagSelectionButton[i - 1], "RIGHT", 20, 0); end
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetShown(i >= xBagPerDB.SelectionButtonIndex and i <= (xBagPerDB.SelectionButtonIndex + 4))
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Index = xBag.Frames.ExtraBag[0].BagSelectionButton[i]:CreateFontString(nil, "OVERLAY")
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Index:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Index:SetFontObject("NumberFontNormal")
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Index:SetPoint("TOPLEFT", 2, -4)
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Index:SetTextColor(1, 0.88, 0.04, 1)
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Index:SetText(i)
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Name = xBag.Frames.ExtraBag[0].BagSelectionButton[i]:CreateFontString(nil, "OVERLAY")
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Name:SetFont("Fonts\\FRIZQT__.TTF", 10)
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Name:SetPoint("TOP", xBag.Frames.ExtraBag[0].BagSelectionButton[i], "BOTTOM", 0, -2)
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Name:SetTextColor(0.6, 0.8, 0.19, 1)
xBag.Functions.SetBagName(xBag.Frames.ExtraBag[0].BagSelectionButton[i].Name, xBagPerDB.BagList[i].Name)
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Name:SetShown(xBagPerDB.Options.ShowBagName)
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Disabled = CreateFrame("Frame", nil, xBag.Frames.ExtraBag[0].BagSelectionButton[i], BackdropTemplateMixin and "BackdropTemplate")
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Disabled:SetSize(27, 27)
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Disabled:SetPoint("BOTTOMRIGHT")
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Disabled:SetBackdrop({bgFile = "Interface\\BUTTONS\\UI-GROUPLOOT-PASS-DOWN"})
xBag.Frames.ExtraBag[0].BagSelectionButton[i].Disabled:SetShown(not xBagPerDB.BagList[i].Filter)
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetScript("OnClick", function(Self, Button)
if (Button == "LeftButton") then
if (xBagPerDB.BagList[i].Filter) then
if (UIDROPDOWNMENU_OPEN_MENU and UIDROPDOWNMENU_OPEN_MENU.xMenu) then CloseDropDownMenus(); end
if (xBagPerDB.Options.HideEmptyBags and (not xBag.Frames.ExtraBag[i]:IsShown()) and #xBag.Data.BagList[i] == 0 and (not IsShiftKeyDown())) then return; end
xBag.Frames.ExtraBag[i]:SetShown(not xBag.Frames.ExtraBag[i]:IsShown())
end
else
GameTooltip_Hide()
if (xBag.Frames.FilterMenu.xIndex == i) then
if (not xBag.Frames.FilterMenu.xShown) then
ToggleDropDownMenu(1, nil, xBag.Frames.FilterMenu, Self, -7, 0)
xBag.Frames.FilterMenu.xShown = true
end
else
xBag.Frames.FilterMenu.xIndex = i
ToggleDropDownMenu(1, nil, xBag.Frames.FilterMenu, Self, -7, 0)
xBag.Frames.FilterMenu.xShown = true
end
end
end)
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetScript("OnEnter", function(Self)
if (xBagPerDB.BagList[i].Name) then
GameTooltip:SetOwner(Self, "ANCHOR_LEFT")
GameTooltip:SetText(xBagPerDB.BagList[i].Name, nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end
xBag.Frames.FilterMenu.xShown = true
end)
xBag.Frames.ExtraBag[0].BagSelectionButton[i]:SetScript("OnLeave", function() GameTooltip_Hide() end)
end
xBag.Frames.ExtraBag[0].ToggleAll = CreateFrame("Button", "xBagToggleAll", xBag.Frames.ExtraBag[0].BagSelectionContainer)
xBag.Frames.ExtraBag[0].ToggleAll:SetSize(32, 32)
xBag.Frames.ExtraBag[0].ToggleAll:SetNormalTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Up")
xBag.Frames.ExtraBag[0].ToggleAll:SetPushedTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Down")
xBag.Frames.ExtraBag[0].ToggleAll:SetHighlightTexture("Interface\\MINIMAP\\UI-Minimap-ZoomButton-Highlight")
xBag.Frames.ExtraBag[0].ToggleAll:SetPoint("RIGHT", 6, 0)
xBag.Frames.ExtraBag[0].ToggleAll:SetScript("OnClick", function() xBag.Functions.ToggleAll(false) end)
xBag.Frames.ExtraBag[0].ToggleAll:SetScript("OnEnter", function(Self)
GameTooltip:SetOwner(Self, "ANCHOR_LEFT")
GameTooltip:SetText(L["Toggle All"], nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end)
xBag.Frames.ExtraBag[0].ToggleAll:SetScript("OnLeave", function() GameTooltip_Hide() end)
xBag.Frames.ExtraBag[0].SequenceUp = CreateFrame("Button", nil, xBag.Frames.ExtraBag[0].BagSelectionContainer)
xBag.Frames.ExtraBag[0].SequenceUp:SetSize(25, 25)
xBag.Frames.ExtraBag[0].SequenceUp:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Up")
xBag.Frames.ExtraBag[0].SequenceUp:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
xBag.Frames.ExtraBag[0].SequenceUp:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Down")
xBag.Frames.ExtraBag[0].SequenceUp:SetPoint("TOPRIGHT", -26, 4)
xBag.Frames.ExtraBag[0].SequenceUp:SetScript("OnClick", function() xBag.Functions.BagScroll(1, false) end)
xBag.Frames.ExtraBag[0].SequenceDown = CreateFrame("Button", nil, xBag.Frames.ExtraBag[0].BagSelectionContainer)
xBag.Frames.ExtraBag[0].SequenceDown:SetSize(25, 25)
xBag.Frames.ExtraBag[0].SequenceDown:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
xBag.Frames.ExtraBag[0].SequenceDown:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
xBag.Frames.ExtraBag[0].SequenceDown:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Down")
xBag.Frames.ExtraBag[0].SequenceDown:SetPoint("BOTTOMRIGHT", -26, -4)
xBag.Frames.ExtraBag[0].SequenceDown:SetScript("OnClick", function() xBag.Functions.BagScroll(-1, false) end)
xBag.Frames.ExtraBag[0].Sort = CreateFrame("Button", nil, xBag.Frames.ExtraBag[0].Display)
xBag.Frames.ExtraBag[0].Sort:SetNormalTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.ExtraBag[0].Sort:SetHighlightTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.ExtraBag[0].Sort:SetPushedTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.ExtraBag[0].Sort:GetNormalTexture():SetTexCoord(0, 0.25, 0.5, 1)
xBag.Frames.ExtraBag[0].Sort:GetHighlightTexture():SetTexCoord(0.25, 0.5, 0.5, 1)
xBag.Frames.ExtraBag[0].Sort:GetPushedTexture():SetTexCoord(0.5, 0.75, 0.5, 1)
xBag.Frames.ExtraBag[0].Sort:RegisterForClicks("AnyUp")
xBag.Frames.ExtraBag[0].Sort:SetSize(28, 28)
xBag.Frames.ExtraBag[0].Sort:SetPoint("TOPLEFT", 0, 0)
xBag.Frames.ExtraBag[0].Sort:SetScript("OnClick", function()
SortBags()
xBag.Functions.RefreshBags(false)
end)
xBag.Frames.ExtraBag[0].Sort:SetScript("OnEnter", function(Self)
GameTooltip:SetOwner(Self, "ANCHOR_LEFT")
GameTooltip:SetText(L["Sort And Filter"], nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end)
xBag.Frames.ExtraBag[0].Sort:SetScript("OnLeave", function() GameTooltip_Hide() end)
xBag.Frames.ExtraBag[0].Money = CreateFrame("Frame", nil, xBag.Frames.ExtraBag[0], "ThinGoldEdgeTemplate")
xBag.Frames.ExtraBag[0].Money:SetSize(165, 25)
xBag.Frames.ExtraBag[0].Money:SetPoint("BOTTOMLEFT", 12.999998092651, 12.999997138977)
xBag.Frames.FilterMenu = CreateFrame("Frame", nil, UIParent, "UIDropDownMenuTemplate")
xBag.Frames.FilterMenu.displayMode = "MENU"
xBag.Frames.FilterMenu.xMenu = true
UIDropDownMenu_Initialize(xBag.Frames.FilterMenu, function(Self, Level) xBag.Functions.InitMenu(Self, Level, false) end)
xBag.Frames.OptionsMenu = CreateFrame("Frame", nil, UIParent, "UIDropDownMenuTemplate")
xBag.Frames.OptionsMenu.displayMode = "MENU"
UIDropDownMenu_Initialize(xBag.Frames.OptionsMenu, xBag.Functions.InitOptionsMenu)
xBag.Frames.BankBag, xBag.Frames.BankBagHighlight = {}, {}
for i = 0, xBag.Data.MaxBags do
if (i == 0) then
xBag.Frames.BankBag[i] = CreateFrame("Frame", "xBagBank", UIParent, BackdropTemplateMixin and "BackdropTemplate")
xBag.Frames.BankBag[i]:SetSize(359.00003051758, 588.00067138672)
else
xBag.Frames.BankBagHighlight[i] = CreateFrame("Frame", nil, UIParent)
xBag.Frames.BankBagHighlight[i]:SetFrameStrata("HIGH")
xBag.Frames.BankBagHighlight[i]:SetFrameLevel(999)
local Tex = xBag.Frames.BankBagHighlight[i]:CreateTexture(nil, "ARTWORK")
Tex:SetColorTexture(0.6, 0.19, 0.8, 1)
Tex:SetAllPoints()
xBag.Frames.BankBagHighlight[i]:Hide()
xBag.Frames.BankBag[i] = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
xBag.Frames.BankBag[i]:SetWidth(195.00003051758)
xBag.Frames.BankBagHighlight[i]:SetAllPoints(xBag.Frames.BankBag[i])
xBag.Frames.BankBag[i].AlwaysShow = CreateFrame("CheckButton", nil, xBag.Frames.BankBag[i], "UICheckButtonTemplate")
xBag.Frames.BankBag[i].AlwaysShow:SetSize(25, 25)
xBag.Frames.BankBag[i].AlwaysShow:SetPoint("TOPLEFT", 8, -7)
xBag.Frames.BankBag[i].AlwaysShow:SetChecked(xBagPerDB.AlwaysShowBank[i])
xBag.Frames.BankBag[i].AlwaysShow:SetScript("OnClick", function(Self) xBagPerDB.AlwaysShowBank[i] = Self:GetChecked() end)
xBag.Frames.BankBag[i].AlwaysShow:SetScript("OnEnter", function(Self)
GameTooltip:SetOwner(Self, "ANCHOR_LEFT")
GameTooltip:SetText(L["Always Show"], nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end)
xBag.Frames.BankBag[i].AlwaysShow:SetScript("OnLeave", function() GameTooltip_Hide() end)
end
xBag.Frames.BankBag[i]:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Rock", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", tile = false, insets = {left = 8, right = 8, top = 8, bottom = 8}, tileSize = 0, edgeSize = 24}
xBag.Frames.BankBag[i]:SetID(i)
xBag.Frames.BankBag[i]:EnableMouse(true)
xBag.Frames.BankBag[i]:SetFrameStrata("HIGH")
xBag.Frames.BankBag[i]:SetFrameLevel(1000)
xBag.Frames.BankBag[i]:SetShown(false)
xBag.Frames.BankBag[i].Header = CreateFrame("Frame", nil, xBag.Frames.BankBag[i], BackdropTemplateMixin and "BackdropTemplate")
xBag.Frames.BankBag[i].Header:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Rock", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", tile = false, insets = {left = 8, right = 8, top = 8, bottom = 8}, tileSize = 0, edgeSize = 24}
xBag.Frames.BankBag[i].Header:SetSize(130, 37)
xBag.Frames.BankBag[i].Header:SetPoint("TOP", 0, 12)
xBag.Frames.BankBag[i].Title = xBag.Frames.BankBag[i].Header:CreateFontString(nil, "ARTWORK")
xBag.Frames.BankBag[i].Title:SetFontObject("GameFontNormal")
xBag.Frames.BankBag[i].Title:SetTextColor(0.41, 0.8, 0.94, 1)
xBag.Frames.BankBag[i].Title:SetPoint("CENTER")
xBag.Functions.SetBagTitleName(xBag.Frames.BankBag[i].Title, xBagPerDB.BankBagList[i].Name)
xBag.Frames.BankBag[i].Close = CreateFrame("Button", nil, xBag.Frames.BankBag[i], "UIPanelCloseButton")
xBag.Frames.BankBag[i].Close:SetSize(32, 32)
xBag.Frames.BankBag[i].Display = CreateFrame("Frame", nil, xBag.Frames.BankBag[i])
xBag.Frames.BankBag[i].Display:SetSize(1, 1)
xBag.Frames.BankBag[i]:SetScript("OnMouseWheel", function(Self, Delta) xBag.Functions.ListScroll(Self, Delta, true) end)
xBag.Frames.BankBag[i]:SetScript("OnShow", function(Self)
if (i == 0) then
for i = 0, xBag.Data.MaxBags do wipe(xBag.Data.BankBagList[i]) end
xBag.Functions.OpenCloseBags(true, true)
if (xBagPerDB.Options.IgnoreShow) then
for i = 1, xBag.Data.MaxBags do if (xBag.Frames.BankBag[i]:IsShown()) then xBag.Frames.BankBag[i]:Hide(); end end
else
for i = 1, xBag.Data.MaxBags do xBag.Frames.BankBag[i]:SetShown(xBagPerDB.AlwaysShowBank[i] and (not xBagPerDB.Options.HideEmptyBags or (xBagPerDB.Options.HideEmptyBags and #xBag.Data.BankBagList[i] > 0))) end
end
else
xBag.Functions.ResizeBag(i, true)
xBag.Functions.OpenExtraBag(i, true)
end
xBag.Functions.UpdateBags(true, i, xBag.Functions.GetBagIndex(i, true))
end)
xBag.Frames.BankBag[i]:SetScript("OnHide", function()
if (i == 0) then
for _, v in pairs (xBag.Data.ExtraBankBagsOpen) do xBag.Frames.BankBag[v]:Hide() end
xBag.Functions.OpenCloseBags(true, false)
else
xBag.Functions.CloseExtraBag(i, true)
if (xBag.Frames.RenameBag.xisBank) then xBag.Frames.RenameBag:Hide(); end
end
end)
if (i == 0) then
xBag.Frames.BankBag[i].Close:SetPoint("TOPRIGHT", -5, -5)
xBag.Frames.BankBag[i].Display:SetPoint("TOPLEFT", 13.999998092651, -27.999994277954)
else
xBag.Frames.BankBag[i].Close:SetPoint("TOPRIGHT", -3, -3)
xBag.Frames.BankBag[i].Display:SetPoint("TOPLEFT", 15, -34)
xBag.Frames.BankBag[i].Header:HookScript("OnMouseUp", function(Self, Button)
if (xBagPerDB.BankBagList[i].Filter == 1) then
xBag.Frames.BankBagHighlight[i]:Hide()
if (Button == "LeftButton") then
local ItemType, ItemID = GetCursorInfo()
if (ItemType == "item" and ItemID) then xBag.Functions.AddCustom(true, i, ItemID); end
elseif (Button == "RightButton") then
xBag.Functions.RenameBag(true, i)
end
ClearCursor()
end
end)
xBag.Frames.BankBag[i].Header:HookScript("OnReceiveDrag", function()
if (xBagPerDB.BankBagList[i].Filter == 1) then
xBag.Frames.BankBagHighlight[i]:Hide()
local ItemType, ItemID = GetCursorInfo()
if (ItemType == "item" and ItemID) then xBag.Functions.AddCustom(true, i, ItemID); end
end
ClearCursor()
end)
xBag.Frames.BankBag[i].Header:HookScript("OnEnter", function()
if (xBagPerDB.BankBagList[i].Filter == 1) then
local ItemType, ItemID = GetCursorInfo()
if (ItemType == "item" and ItemID) then xBag.Frames.BankBagHighlight[i]:Show(); end
end
end)
xBag.Frames.BankBag[i].Header:HookScript("OnLeave", function() xBag.Frames.BankBagHighlight[i]:Hide() end)
xBag.Frames.BankBag[i]:SetScript("OnLeave", function(Self)
if (Self.xResize) then
Self.xResize = nil
xBag.Functions.ResizeBag(i, true)
end
end)
end
end
tinsert(UISpecialFrames, "xBagBank")
xBag.Frames.BankBag[0]:SetClampedToScreen(true)
xBag.Frames.BankBag[0]:SetClampRectInsets(-9, 0, 13, 0)
xBag.Frames.BankBag[0]:SetMovable(true)
xBag.Frames.BankBag[0]:RegisterForDrag("LeftButton")
if (xBagPerDB and xBagPerDB.MainBankBagPoints) then xBag.Frames.BankBag[0]:SetPoint(xBagPerDB.MainBankBagPoints[1], xBagPerDB.MainBankBagPoints[2], xBagPerDB.MainBankBagPoints[3], xBagPerDB.MainBankBagPoints[4], xBagPerDB.MainBankBagPoints[5]); else xBag.Frames.BankBag[0]:SetPoint("TOPLEFT", 0, -100); end
xBag.Frames.BankBag[0].Header:EnableMouse(true)
xBag.Frames.BankBag[0].Header:RegisterForDrag("LeftButton")
xBag.Frames.BankBag[0].BagSelectionContainer = CreateFrame("Frame", nil, xBag.Frames.BankBag[0])
xBag.Frames.BankBag[0].BagSelectionContainer:SetSize(330, 37)
xBag.Frames.BankBag[0].BagSelectionContainer:SetPoint("TOPLEFT", 13, -64)
xBag.Frames.BankBag[0].BagSelectionContainer:SetScript("OnMouseWheel", function(Self, Delta) xBag.Functions.BagScroll(Delta, true) end)
xBag.Frames.BankBag[0].BagSelectionButton = {}
for i = 1, xBag.Data.MaxBags do
xBag.Frames.BankBag[0].BagSelectionButton[i] = CreateFrame("DropDownToggleButton", nil, xBag.Frames.BankBag[0].BagSelectionContainer)
xBag.Frames.BankBag[0].BagSelectionButton[i]:RegisterForClicks("AnyUp")
xBag.Frames.BankBag[0].BagSelectionButton[i]:RegisterForMouse("LeftButtonDown", "LeftButtonUp", "RightButtonDown", "RightButtonUp")
xBag.Frames.BankBag[0].BagSelectionButton[i]:SetNormalTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.BankBag[0].BagSelectionButton[i]:SetHighlightTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.BankBag[0].BagSelectionButton[i]:SetPushedTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.BankBag[0].BagSelectionButton[i]:GetNormalTexture():SetTexCoord(0, 0.25, 0, 0.5)
xBag.Frames.BankBag[0].BagSelectionButton[i]:GetHighlightTexture():SetTexCoord(0.25, 0.5, 0, 0.5)
xBag.Frames.BankBag[0].BagSelectionButton[i]:GetPushedTexture():SetTexCoord(0.5, 0.75, 0, 0.5)
xBag.Frames.BankBag[0].BagSelectionButton[i]:SetSize(37, 37)
if (i == 1 or i == 6 or i == 11 or i == 16 or i == 21 or i == 26) then xBag.Frames.BankBag[0].BagSelectionButton[i]:SetPoint("LEFT", 8, 0); else xBag.Frames.BankBag[0].BagSelectionButton[i]:SetPoint("LEFT", xBag.Frames.BankBag[0].BagSelectionButton[i - 1], "RIGHT", 20, 0); end
xBag.Frames.BankBag[0].BagSelectionButton[i]:SetShown(i >= xBagPerDB.SelectionButtonIndexBank and i <= (xBagPerDB.SelectionButtonIndexBank + 4))
xBag.Frames.BankBag[0].BagSelectionButton[i].Index = xBag.Frames.BankBag[0].BagSelectionButton[i]:CreateFontString(nil, "OVERLAY")
xBag.Frames.BankBag[0].BagSelectionButton[i].Index:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
xBag.Frames.BankBag[0].BagSelectionButton[i].Index:SetFontObject("NumberFontNormal")
xBag.Frames.BankBag[0].BagSelectionButton[i].Index:SetPoint("TOPLEFT", 2, -4)
xBag.Frames.BankBag[0].BagSelectionButton[i].Index:SetTextColor(1, 0.88, 0.04, 1)
xBag.Frames.BankBag[0].BagSelectionButton[i].Index:SetText(i)
xBag.Frames.BankBag[0].BagSelectionButton[i].Name = xBag.Frames.BankBag[0].BagSelectionButton[i]:CreateFontString(nil, "OVERLAY")
xBag.Frames.BankBag[0].BagSelectionButton[i].Name:SetFont("Fonts\\FRIZQT__.TTF", 10)
xBag.Frames.BankBag[0].BagSelectionButton[i].Name:SetPoint("TOP", xBag.Frames.BankBag[0].BagSelectionButton[i], "BOTTOM", 0, -2)
xBag.Frames.BankBag[0].BagSelectionButton[i].Name:SetTextColor(0.6, 0.8, 0.19, 1)
xBag.Functions.SetBagName(xBag.Frames.BankBag[0].BagSelectionButton[i].Name, xBagPerDB.BankBagList[i].Name)
xBag.Frames.BankBag[0].BagSelectionButton[i].Name:SetShown(xBagPerDB.Options.ShowBagName)
xBag.Frames.BankBag[0].BagSelectionButton[i].Disabled = CreateFrame("Frame", nil, xBag.Frames.BankBag[0].BagSelectionButton[i], BackdropTemplateMixin and "BackdropTemplate")
xBag.Frames.BankBag[0].BagSelectionButton[i].Disabled:SetSize(27, 27)
xBag.Frames.BankBag[0].BagSelectionButton[i].Disabled:SetPoint("BOTTOMRIGHT")
xBag.Frames.BankBag[0].BagSelectionButton[i].Disabled:SetBackdrop({bgFile = "Interface\\BUTTONS\\UI-GROUPLOOT-PASS-DOWN"})
xBag.Frames.BankBag[0].BagSelectionButton[i].Disabled:SetShown(not xBagPerDB.BankBagList[i].Filter)
xBag.Frames.BankBag[0].BagSelectionButton[i]:SetScript("OnClick", function(Self, Button)
if (Button == "LeftButton") then
if (xBagPerDB.BankBagList[i].Filter) then
if (UIDROPDOWNMENU_OPEN_MENU and UIDROPDOWNMENU_OPEN_MENU.xMenu) then CloseDropDownMenus(); end
if (xBagPerDB.Options.HideEmptyBags and (not xBag.Frames.BankBag[i]:IsShown()) and #xBag.Data.BankBagList[i] == 0 and (not IsShiftKeyDown())) then return; end
xBag.Frames.BankBag[i]:SetShown(not xBag.Frames.BankBag[i]:IsShown())
end
else
GameTooltip_Hide()
if (xBag.Frames.BankFilterMenu.xIndex == i) then
if (not xBag.Frames.BankFilterMenu.xShown) then
ToggleDropDownMenu(1, nil, xBag.Frames.BankFilterMenu, Self, -7, 0)
xBag.Frames.BankFilterMenu.xShown = true
end
else
xBag.Frames.BankFilterMenu.xIndex = i
ToggleDropDownMenu(1, nil, xBag.Frames.BankFilterMenu, Self, -7, 0)
xBag.Frames.BankFilterMenu.xShown = true
end
end
end)
xBag.Frames.BankBag[0].BagSelectionButton[i]:SetScript("OnEnter", function(Self)
if (xBagPerDB.BankBagList[i].Name) then
GameTooltip:SetOwner(Self, "ANCHOR_LEFT")
GameTooltip:SetText(xBagPerDB.BankBagList[i].Name, nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end
xBag.Frames.BankFilterMenu.xShown = true
end)
xBag.Frames.BankBag[0].BagSelectionButton[i]:SetScript("OnLeave", function() GameTooltip_Hide() end)
end
xBag.Frames.BankBag[0].ToggleAll = CreateFrame("Button", nil, xBag.Frames.BankBag[0].BagSelectionContainer)
xBag.Frames.BankBag[0].ToggleAll:SetSize(32, 32)
xBag.Frames.BankBag[0].ToggleAll:SetNormalTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Up")
xBag.Frames.BankBag[0].ToggleAll:SetPushedTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Down")
xBag.Frames.BankBag[0].ToggleAll:SetHighlightTexture("Interface\\MINIMAP\\UI-Minimap-ZoomButton-Highlight")
xBag.Frames.BankBag[0].ToggleAll:SetPoint("RIGHT", 6, 0)
xBag.Frames.BankBag[0].ToggleAll:SetScript("OnClick", function() xBag.Functions.ToggleAll(true) end)
xBag.Frames.BankBag[0].ToggleAll:SetScript("OnEnter", function(Self)
GameTooltip:SetOwner(Self, "ANCHOR_LEFT")
GameTooltip:SetText(L["Toggle All"], nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end)
xBag.Frames.BankBag[0].ToggleAll:SetScript("OnLeave", function() GameTooltip_Hide() end)
xBag.Frames.BankBag[0].SequenceUp = CreateFrame("Button", nil, xBag.Frames.BankBag[0].BagSelectionContainer)
xBag.Frames.BankBag[0].SequenceUp:SetSize(25, 25)
xBag.Frames.BankBag[0].SequenceUp:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Up")
xBag.Frames.BankBag[0].SequenceUp:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
xBag.Frames.BankBag[0].SequenceUp:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Down")
xBag.Frames.BankBag[0].SequenceUp:SetPoint("TOPRIGHT", -26, 4)
xBag.Frames.BankBag[0].SequenceUp:SetScript("OnClick", function() xBag.Functions.BagScroll(1, true) end)
xBag.Frames.BankBag[0].SequenceDown = CreateFrame("Button", nil, xBag.Frames.BankBag[0].BagSelectionContainer)
xBag.Frames.BankBag[0].SequenceDown:SetSize(25, 25)
xBag.Frames.BankBag[0].SequenceDown:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
xBag.Frames.BankBag[0].SequenceDown:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
xBag.Frames.BankBag[0].SequenceDown:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Down")
xBag.Frames.BankBag[0].SequenceDown:SetPoint("BOTTOMRIGHT", -26, -4)
xBag.Frames.BankBag[0].SequenceDown:SetScript("OnClick", function() xBag.Functions.BagScroll(-1, true) end)
xBag.Frames.BankBag[0].Sort = CreateFrame("Button", nil, xBag.Frames.BankBag[0])
xBag.Frames.BankBag[0].Sort:SetNormalTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.BankBag[0].Sort:SetHighlightTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.BankBag[0].Sort:SetPushedTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.BankBag[0].Sort:GetNormalTexture():SetTexCoord(0, 0.25, 0.5, 1)
xBag.Frames.BankBag[0].Sort:GetHighlightTexture():SetTexCoord(0.25, 0.5, 0.5, 1)
xBag.Frames.BankBag[0].Sort:GetPushedTexture():SetTexCoord(0.5, 0.75, 0.5, 1)
xBag.Frames.BankBag[0].Sort:RegisterForClicks("AnyUp")
xBag.Frames.BankBag[0].Sort:SetSize(28, 28)
xBag.Frames.BankBag[0].Sort:SetPoint("TOPLEFT", xBag.Frames.BankBag[0].Display, "TOPLEFT", 0, 0)
xBag.Frames.BankBag[0].Sort:SetScript("OnClick", function()
SortBankBags()
xBag.Functions.RefreshBags(true)
end)
xBag.Frames.BankBag[0].Sort:SetScript("OnEnter", function(Self)
GameTooltip:SetOwner(Self, "ANCHOR_LEFT")
GameTooltip:SetText(L["Sort And Filter"], nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end)
xBag.Frames.BankBag[0].Sort:SetScript("OnLeave", function() GameTooltip_Hide() end)
BankItemSearchBox:ClearAllPoints()
BankItemSearchBox:SetParent(xBag.Frames.BankBag[0])
BankItemSearchBox:SetWidth(150)
BankItemSearchBox:SetPoint("LEFT", xBag.Frames.BankBag[0].Sort, "RIGHT", 20, 0)
BankItemAutoSortButton:Hide()
xBag.Frames.BankBag[0].Money = CreateFrame("Frame", nil, xBag.Frames.BankBag[0], "ThinGoldEdgeTemplate")
xBag.Frames.BankBag[0].Money:SetSize(165, 25)
xBag.Frames.BankBag[0].Money:SetPoint("BOTTOMLEFT", 12.999998092651, 12.999997138977)
BankFrameMoneyFrame:ClearAllPoints()
BankFrameMoneyFrame:SetParent(xBag.Frames.BankBag[0].Money)
BankFrameMoneyFrame:SetPoint("RIGHT", 10, -2)
xBag.Frames.BankBag[0].ToggleReagentBank = CreateFrame("Button", nil, xBag.Frames.BankBag[0], "UIMenuButtonStretchTemplate")
xBag.Frames.BankBag[0].ToggleReagentBank:SetSize(130, 25)
xBag.Frames.BankBag[0].ToggleReagentBank:SetPoint("BOTTOMRIGHT", -12.999998092651, 12.999997138977)
xBag.Frames.BankBag[0].ToggleReagentBank:SetText(" "..L["Toggle Reagent Bank"])
xBag.Frames.BankBag[0].ToggleReagentBank:SetScript("OnClick", xBag.Functions.ToggleReagentBank)
xBag.Frames.BankFilterMenu = CreateFrame("Frame", nil, UIParent, "UIDropDownMenuTemplate")
xBag.Frames.BankFilterMenu.displayMode = "MENU"
xBag.Frames.BankFilterMenu.xMenu = true
UIDropDownMenu_Initialize(xBag.Frames.BankFilterMenu, function(Self, Level) xBag.Functions.InitMenu(Self, Level, true) end)
xBag.Frames.ReagentBag = CreateFrame("Frame", "xBagReagent", UIParent, BackdropTemplateMixin and "BackdropTemplate")
xBag.Frames.ReagentBag:SetSize(610.00006103516, 385.00015258789)
xBag.Frames.ReagentBag:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Rock", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", tile = false, insets = {left = 8, right = 8, top = 8, bottom = 8}, tileSize = 0, edgeSize = 24}
xBag.Frames.ReagentBag:EnableMouse(true)
xBag.Frames.ReagentBag:SetFrameStrata("HIGH")
xBag.Frames.ReagentBag:SetShown(false)
xBag.Frames.ReagentBag:SetClampedToScreen(true)
xBag.Frames.ReagentBag:SetClampRectInsets(-9, 0, 13, 0)
xBag.Frames.ReagentBag:SetMovable(true)
xBag.Frames.ReagentBag:RegisterForDrag("LeftButton")
if (xBagPerDB and xBagPerDB.ReagentBankPoints) then xBag.Frames.ReagentBag:SetPoint(xBagPerDB.ReagentBankPoints[1], xBagPerDB.ReagentBankPoints[2], xBagPerDB.ReagentBankPoints[3], xBagPerDB.ReagentBankPoints[4], xBagPerDB.ReagentBankPoints[5]); else xBag.Frames.ReagentBag:SetPoint("BOTTOMLEFT", 0, 0); end
tinsert(UISpecialFrames, "xBagReagent")
xBag.Frames.ReagentBag.Header = CreateFrame("Frame", nil, xBag.Frames.ReagentBag, BackdropTemplateMixin and "BackdropTemplate")
xBag.Frames.ReagentBag.Header:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Rock", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", tile = false, insets = {left = 8, right = 8, top = 8, bottom = 8}, tileSize = 0, edgeSize = 24}
xBag.Frames.ReagentBag.Header:SetSize(130, 37)
xBag.Frames.ReagentBag.Header:SetPoint("TOP", 0, 12)
xBag.Frames.ReagentBag.Header:EnableMouse(true)
xBag.Frames.ReagentBag.Header:RegisterForDrag("LeftButton")
xBag.Frames.ReagentBag.Title = xBag.Frames.ReagentBag.Header:CreateFontString(nil, "ARTWORK")
xBag.Frames.ReagentBag.Title:SetFontObject("GameFontNormal")
xBag.Frames.ReagentBag.Title:SetPoint("CENTER")
xBag.Frames.ReagentBag.Title:SetText(L["Reagent Bank"])
xBag.Frames.ReagentBag.Close = CreateFrame("Button", nil, xBag.Frames.ReagentBag, "UIPanelCloseButton")
xBag.Frames.ReagentBag.Close:SetSize(32, 32)
xBag.Frames.ReagentBag.Close:SetPoint("TOPRIGHT", -5, -5)
xBag.Frames.ReagentBag.Display = CreateFrame("Frame", nil, xBag.Frames.ReagentBag)
xBag.Frames.ReagentBag.Display:SetSize(1, 1)
xBag.Frames.ReagentBag.Display:SetPoint("TOPLEFT", 13.999998092651, -48.999988555908)
ReagentBankFrame.DespositButton:ClearAllPoints()
ReagentBankFrame.DespositButton:SetParent(xBag.Frames.ReagentBag)
ReagentBankFrame.DespositButton:SetPoint("BOTTOM", 0, 12.999997138977)
ReagentBankFrame.DespositButton:SetScript("OnClick", function()
for BagID = 0, NUM_BAG_SLOTS do
for SlotID = 1, GetContainerNumSlots(BagID) do
local ItemID = GetContainerItemID(BagID, SlotID)
if (ItemID) then
local ClassID = select(6, GetItemInfoInstant(ItemID))
if (ClassID == LE_ITEM_CLASS_TRADEGOODS) then xBag.Functions.ClearNewItems(false, BagID, SlotID); end
end
end
end
DepositReagentBank()
end)
xBag.Frames.ReagentBag.Sort = CreateFrame("Button", nil, xBag.Frames.ReagentBag)
xBag.Frames.ReagentBag.Sort:SetNormalTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.ReagentBag.Sort:SetHighlightTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.ReagentBag.Sort:SetPushedTexture("Interface\\Addons\\xBag\\Images\\icons")
xBag.Frames.ReagentBag.Sort:GetNormalTexture():SetTexCoord(0, 0.25, 0.5, 1)
xBag.Frames.ReagentBag.Sort:GetHighlightTexture():SetTexCoord(0.25, 0.5, 0.5, 1)
xBag.Frames.ReagentBag.Sort:GetPushedTexture():SetTexCoord(0.5, 0.75, 0.5, 1)
xBag.Frames.ReagentBag.Sort:RegisterForClicks("AnyUp")
xBag.Frames.ReagentBag.Sort:SetSize(28, 28)
xBag.Frames.ReagentBag.Sort:SetPoint("TOPLEFT", 13.999998092651, -13.999998092651)
xBag.Frames.ReagentBag.Sort:SetScript("OnClick", function() SortReagentBankBags() end)
xBag.Frames.ReagentBag.Sort:SetScript("OnEnter", function(Self)
GameTooltip:SetOwner(Self, "ANCHOR_LEFT")
GameTooltip:SetText(L["Sort"], nil, nil, nil, nil, true)
GameTooltip:SetFrameStrata("TOOLTIP")
GameTooltip:Show()
end)
xBag.Frames.ReagentBag.Sort:SetScript("OnLeave", function() GameTooltip_Hide() end)
xBag.Frames.SetBinding = CreateFrame("Cooldown", nil, xBag.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
xBag.Frames.SetBinding:SetAttribute("_onshow", [=[
self:Hide()
local Set, Index, Key = self:GetAttribute("Set"), self:GetAttribute("Index"), self:GetAttribute("Key")
local Ref = self:GetFrameRef("Index"..Index)
if (Set) then Ref:SetBindingClick(false, Key, Ref:GetName(), "LeftButton"); else Ref:ClearBinding(Key); end
]=])
for i = 1, 6 do xBag.Frames.SetBinding:SetFrameRef("Index"..i, xBag.Frames.UIBagButton[i - 1]) end
xBag.Frames.SetBinding:SetFrameRef("Index7", xBag.Frames.ExtraBag[0].ToggleAll)
xBag.Frames.SetBindingsDisplay = CreateFrame("Frame", "xBagSetBinding", UIParent, "TooltipBorderedFrameTemplate")
tinsert(UISpecialFrames, "xBagSetBinding")
xBag.Frames.SetBindingsDisplay:SetFrameStrata("TOOLTIP")
xBag.Frames.SetBindingsDisplay:SetMovable(true)
xBag.Frames.SetBindingsDisplay:RegisterForDrag("LeftButton")
xBag.Frames.SetBindingsDisplay:EnableMouse(true)
xBag.Frames.SetBindingsDisplay:SetSize(278, 280)
xBag.Frames.SetBindingsDisplay:SetPoint("CENTER")
xBag.Frames.SetBindingsDisplay:Hide()
xBag.Frames.SetBindingsDisplay.Close = CreateFrame("Button", nil, xBag.Frames.SetBindingsDisplay, "UIPanelCloseButton")
xBag.Frames.SetBindingsDisplay.Close:SetSize(35, 35)
xBag.Frames.SetBindingsDisplay.Close:SetPoint("TOPRIGHT", 0, 0)
xBag.Frames.SetBindingsDisplay.Titles, xBag.Frames.SetBindingsDisplay.Edit = {}, {}
local TitleText = {L["Main Bag"], L["UI Bag"], L["Toggle All"]}
local Top = -38
for i = 1, 7 do
xBag.Frames.SetBindingsDisplay.Titles[i] = xBag.Frames.SetBindingsDisplay:CreateFontString(nil, "ARTWORK")
xBag.Frames.SetBindingsDisplay.Titles[i]:SetFont("Fonts\\FRIZQT__.TTF", 14)
xBag.Frames.SetBindingsDisplay.Titles[i]:SetFontObject("GameFontNormal")
xBag.Frames.SetBindingsDisplay.Titles[i]:SetPoint("TOPLEFT", xBag.Frames.SetBindingsDisplay, "TOPLEFT", 15, Top)
if (i == 7) then
xBag.Frames.SetBindingsDisplay.Titles[i]:SetTextColor(1, 0.49, 0.04, 1)
xBag.Frames.SetBindingsDisplay.Titles[i]:SetText(TitleText[3])
elseif (i == 1) then
xBag.Frames.SetBindingsDisplay.Titles[i]:SetTextColor(0, 1, 1, 1)
xBag.Frames.SetBindingsDisplay.Titles[i]:SetText(TitleText[1])
else
xBag.Frames.SetBindingsDisplay.Titles[i]:SetText(TitleText[2].." "..(i - 1))
end
xBag.Frames.SetBindingsDisplay.Edit[i] = CreateFrame("Button", nil, xBag.Frames.SetBindingsDisplay, "UIMenuButtonStretchTemplate")
local Name = xBagPerDB.Bindings[i] or L["Not Bound"]
xBag.Frames.SetBindingsDisplay.Edit[i]:SetText("|cfff8f996"..Name)
xBag.Frames.SetBindingsDisplay.Edit[i]:SetSize(164, 25)
xBag.Frames.SetBindingsDisplay.Edit[i]:RegisterForClicks("AnyUp")
xBag.Frames.SetBindingsDisplay.Edit[i]:SetPoint("TOPLEFT", xBag.Frames.SetBindingsDisplay, "TOPLEFT", 100, (Top + 5))
xBag.Frames.SetBindingsDisplay.Edit[i]:SetScript("OnClick", function(Self, Button)
xBag.Frames.SetBindingsDisplay.Key:ClearFocus()
xBag.Frames.SetBindingsDisplay.Key.xIndex = i
if (Button == "LeftButton") then
if (InCombatLockdown()) then
print("|cffffe00a".."(".."|cffff7d0a"..xBag.Data.Title, "v"..xBag.Data.Version.."|cffffe00a"..")", "|cff69ccf0"..L["Unable to change key bindings while in combat"])
else
xBag.Frames.SetBindingsDisplay.Key:SetEnabled(true)
xBag.Frames.SetBindingsDisplay.Key:SetFocus()
xBag.Frames.SetBindingsDisplay.Message:Show()
Self:LockHighlight()
end
else
if (xBagPerDB.Bindings[i]) then
if (InCombatLockdown()) then
print("|cffffe00a".."(".."|cffff7d0a"..xBag.Data.Title, "v"..xBag.Data.Version.."|cffffe00a"..")", "|cff69ccf0"..L["Unable to change key bindings while in combat"])
else
xBag.Functions.SetBinding(i, false)
xBagPerDB.Bindings[i] = false
xBag.Frames.SetBindingsDisplay.Edit[i]:SetText("|cfff8f996"..L["Not Bound"])
end
end
end
end)
Top = Top - 30
end
xBag.Frames.SetBindingsDisplay.Message = xBag.Frames.SetBindingsDisplay:CreateFontString(nil, "ARTWORK")
xBag.Frames.SetBindingsDisplay.Message:SetFont("Fonts\\FRIZQT__.TTF", 14)
xBag.Frames.SetBindingsDisplay.Message:SetFontObject("GameFontNormal")
xBag.Frames.SetBindingsDisplay.Message:SetTextColor(1, 1, 1, 1)
xBag.Frames.SetBindingsDisplay.Message:SetPoint("BOTTOM", 0, 8)
xBag.Frames.SetBindingsDisplay.Message:SetText(L["Press Key to Bind"])
xBag.Frames.SetBindingsDisplay.Message:Hide()
xBag.Frames.SetBindingsDisplay.Key = CreateFrame("EditBox", nil, xBag.Frames.SetBindingsDisplay, "InputBoxTemplate")
xBag.Frames.SetBindingsDisplay.Key:SetSize(0, 0)
xBag.Frames.SetBindingsDisplay.Key:SetEnabled(false)
xBag.Frames.SetBindingsDisplay.Key:SetScript("OnEditFocusLost", function(Self)
Self.xMod = nil
Self:SetText("")
Self:SetEnabled(false)
xBag.Frames.SetBindingsDisplay.Message:Hide()
for i = 1, 7 do xBag.Frames.SetBindingsDisplay.Edit[i]:UnlockHighlight() end
end)
xBag.Frames.SetBindingsDisplay.Key:SetScript("OnKeyDown", function(Self, Key) if (Key == "LSHIFT" or Key == "RSHIFT") then Self.xMod = "SHIFT-"; elseif (Key == "LCTRL" or Key == "RCTRL") then Self.xMod = "CTRL-"; elseif (Key == "LALT" or Key == "RALT") then Self.xMod = "ALT-"; end end)
xBag.Frames.SetBindingsDisplay.Key:SetScript("OnKeyUp", function(Self, Key)
local Binding
if (not (Key == "LSHIFT" or Key == "LALT" or Key == "LCTRL" or Key == "RSHIFT" or Key == "RALT" or Key == "RCTRL")) then
if (Self.xMod) then Binding = Self.xMod..Key; else Binding = Key; end
end
Self:ClearFocus()
if (Binding) then
if (InCombatLockdown()) then
print("|cffffe00a".."(".."|cffff7d0a"..xBag.Data.Title, "v"..xBag.Data.Version.."|cffffe00a"..")", "|cff69ccf0"..L["Unable to change key bindings while in combat"])
else
local Valid = true
for i = 1, 7 do
if (xBagPerDB.Bindings[i] == Binding) then
Valid = false
break
end
end
if (Valid) then
local Index = Self.xIndex
if (xBagPerDB.Bindings[Index] ~= Binding) then
if (xBagPerDB.Bindings[Index]) then xBag.Functions.SetBinding(Index, false); end
xBagPerDB.Bindings[Index] = Binding
xBag.Frames.SetBindingsDisplay.Edit[Index]:SetText("|cfff8f996"..xBagPerDB.Bindings[Index])
xBag.Functions.SetBinding(Index, true)
end
end
end
end
end)
xBag.Frames.UIBagButtonMenu = CreateFrame("Frame", nil, UIParent, "UIDropDownMenuTemplate")
xBag.Frames.UIBagButtonMenu.displayMode = "MENU"
xBag.Frames.UIBagButtonMenu.xMenu = true
UIDropDownMenu_Initialize(xBag.Frames.UIBagButtonMenu, xBag.Functions.InitUIBagButtonMenu)
end
function xBag.Functions.CreateEvents()
xBag.Frames.ExtraBag[0]:SetScript("OnDragStart", xBag.Frames.ExtraBag[0].StartMoving)
xBag.Frames.ExtraBag[0].Header:SetScript("OnDragStart", function() xBag.Frames.ExtraBag[0]:StartMoving() end)
xBag.Frames.ExtraBag[0]:SetScript("OnDragStop", xBag.Functions.xBagMove)
xBag.Frames.ExtraBag[0].Header:SetScript("OnDragStop", xBag.Functions.xBagMove)
xBag.Frames.BankBag[0]:SetScript("OnDragStart", xBag.Frames.BankBag[0].StartMoving)
xBag.Frames.BankBag[0].Header:SetScript("OnDragStart", function() xBag.Frames.BankBag[0]:StartMoving() end)
xBag.Frames.BankBag[0]:SetScript("OnDragStop", xBag.Functions.xBagMove)
xBag.Frames.BankBag[0].Header:SetScript("OnDragStop", xBag.Functions.xBagMove)
xBag.Frames.ReagentBag:SetScript("OnDragStart", xBag.Frames.ReagentBag.StartMoving)
xBag.Frames.ReagentBag.Header:SetScript("OnDragStart", function() xBag.Frames.ReagentBag:StartMoving() end)
xBag.Frames.ReagentBag:SetScript("OnDragStop", xBag.Functions.xBagMove)
xBag.Frames.ReagentBag.Header:SetScript("OnDragStop", xBag.Functions.xBagMove)
xBag.Frames.GuideDisplay:SetScript("OnDragStart", xBag.Frames.GuideDisplay.StartMoving)
xBag.Frames.GuideDisplay:SetScript("OnDragStop", xBag.Frames.GuideDisplay.StopMovingOrSizing)
xBag.Frames.SetBindingsDisplay:SetScript("OnDragStart", xBag.Frames.SetBindingsDisplay.StartMoving)
xBag.Frames.SetBindingsDisplay:SetScript("OnDragStop", xBag.Frames.SetBindingsDisplay.StopMovingOrSizing)
end
SLASH_XBAG1 = "/xBag"
function SlashCmdList.XBAG(msg, editbox)
msg = string.lower(msg)
if (msg == "open") then
if (xBagPerDB.xBagLoaded) then
print("|cffffe00a".."(".."|cffff7d0a"..xBag.Data.Title, "v"..xBag.Data.Version.."|cffffe00a"..")", "|cff69ccf0"..L["xBag already Open!"])
else
xBagPerDB.xBagLoaded = true
ReloadUI()
end
elseif (msg == "close") then
if (not xBagPerDB.xBagLoaded) then
print("|cffffe00a".."(".."|cffff7d0a"..xBag.Data.Title, "v"..xBag.Data.Version.."|cffffe00a"..")", "|cff69ccf0"..L["xBag already Closed!"])
else
xBagPerDB.xBagLoaded = false
ReloadUI()
end
elseif (msg == "binding" or msg == "bindings") then
if (not xBagPerDB.xBagLoaded) then
print("|cffffe00a".."(".."|cffff7d0a"..xBag.Data.Title, "v"..xBag.Data.Version.."|cffffe00a"..")", "|cff69ccf0"..L["xBag must be open to change key bindings"])
else
if (InCombatLockdown()) then print("|cffffe00a".."(".."|cffff7d0a"..xBag.Data.Title, "v"..xBag.Data.Version.."|cffffe00a"..")", "|cff69ccf0"..L["Unable to change key bindings while in combat"]); else xBag.Frames.SetBindingsDisplay:Show(); end
end
elseif (msg == "help") then
if (InCombatLockdown()) then CooldownFrame_Set(xBag.Frames.SlashHelp, 1, 1, true); else xBag.Frames.GuideDisplay:Show(); end
else
print("|cffffe00a".."(".."|cffff7d0a"..xBag.Data.Title, "v"..xBag.Data.Version.."|cffffe00a"..")", "|cff69ccf0"..L["Usage:"])
print("|cffffe00a"..L["/xbag open"].."|r  -  ".."|cfff8f996"..L["Open xBag"].."   "..L["(requires reload)"])
print("|cffffe00a"..L["/xbag close"].."|r  -  ".."|cfff8f996"..L["Close xBag"].."   "..L["(requires reload)"])
print("|cffffe00a"..L["/xbag binding"].."|r  -  ".."|cfff8f996"..L["Change Key Bindings"])
print("|cffffe00a"..L["/xbag help"].."|r  -  ".."|cfff8f996"..L["Show Help"])
end
end
xBag.Frames.Event = CreateFrame("Frame")
xBag.Frames.Event:RegisterEvent("ADDON_LOADED")
xBag.Frames.Event:RegisterEvent("PLAYER_LOGIN")
function xBag.Frames.Event:OnEvent(Event, Self, ...)
if (Event == "ADDON_LOADED") then
if (Self == "xBag") then
xBag.Frames.Event:UnregisterEvent("ADDON_LOADED")
xBag.Data.Title, xBag.Data.Version = GetAddOnMetadata(Self, "Title"), GetAddOnMetadata(Self, "Version")
print(" ")
print("|cffffe00a".."(".."|cffff7d0a"..xBag.Data.Title, "v"..xBag.Data.Version, "|cff69ccf0"..L["Loaded"].."|cffffe00a"..")")
print("|cfff8f996"..L["/xbag"])
end
end
if (Event == "PLAYER_LOGIN") then
xBag.Frames.Event:UnregisterEvent("PLAYER_LOGIN")
xBag.Functions.CreateData()
xBag.Functions.UpdateVersion()
if (xBagPerDB.xBagLoaded) then
xBag.Frames.Event:RegisterEvent("BAG_UPDATE_DELAYED")
xBag.Frames.Event:RegisterEvent("PLAYER_REGEN_DISABLED")
xBag.Frames.Event:RegisterEvent("BANKFRAME_OPENED")
xBag.Frames.Event:RegisterEvent("BANKFRAME_CLOSED")
xBag.Frames.Event:RegisterEvent("MERCHANT_SHOW")
xBag.Frames.Event:RegisterEvent("MERCHANT_CLOSED")
xBag.Frames.Event:RegisterEvent("MAIL_SHOW")
xBag.Frames.Event:RegisterEvent("MAIL_CLOSED")
xBag.Frames.Event:RegisterEvent("AUCTION_HOUSE_SHOW")
xBag.Frames.Event:RegisterEvent("AUCTION_HOUSE_CLOSED")
xBag.Frames.Event:RegisterEvent("GUILDBANKFRAME_OPENED")
xBag.Frames.Event:RegisterEvent("GUILDBANKFRAME_CLOSED")
xBag.Functions.CreateFunctions()
xBag.Functions.CreateHooks()
xBag.Functions.CreateFrames()
xBag.Functions.CreateEvents()
xBag.Functions.SetGlobals()
xBag.Functions.SetBagFilter()
for i = 1, 7 do if (xBagPerDB.Bindings[i]) then xBag.Functions.SetBinding(i, true); end end
xBag.Data.NewFilter = xBag.Functions.HasNewFilter()
if (xBag.Data.NewFilter) then
C_NewItems.RemoveNewItem = function() end
if (xBagPerDB.Options.RememberNew) then
if (xBagPerDB.NewItems) then
xBag.Data.NewItems = {}
for i = 1, #xBagPerDB.NewItems do table.insert(xBag.Data.NewItems, xBagPerDB.NewItems[i]) end
if (#xBag.Data.NewItems == 0) then xBag.Data.NewItems = nil; end
end
end
end
if (xBagPerDB.Options.LootOpen ~= 2) then
xBag.Data.LootID = {}
xBag.Frames.Event:RegisterEvent("CHAT_MSG_LOOT")
end
else
print("|cffffe00a"..L["xBag is closed, type"].." |cfff8f996"..L["/xbag open"].." |r"..L["to open."])
end
if (xBag.Data.UpdateWarning) then
xBag.Data.UpdateWarning = nil
xBag.Functions.UpdateWarning()
end
print(" ")
end
if (Event == "PLAYER_REGEN_DISABLED") then
if (xBag.Frames.SetBindingsDisplay:IsShown()) then xBag.Frames.SetBindingsDisplay:Hide(); end
end
if (Event == "BANKFRAME_OPENED") then
xBag.Frames.BankBag[0]:Show()
if (xBagPerDB.Options.OpenBank) then xBag.Functions.EventBagShow(); end
end
if (Event == "BANKFRAME_CLOSED") then
xBag.Frames.BankBag[0]:Hide()
xBag.Frames.ReagentBag:Hide()
if (xBag.Frames.ExtraBag[0]:IsShown() and xBagPerDB.Options.CloseBank) then xBag.Frames.ExtraBag[0]:Hide(); end
end
if (Event == "MERCHANT_SHOW") then
if (xBagPerDB.Options.OpenMerchant) then xBag.Functions.EventBagShow(); end
end
if (Event == "MERCHANT_CLOSED") then
if (xBag.Frames.ExtraBag[0]:IsShown() and xBagPerDB.Options.CloseMerchant) then xBag.Frames.ExtraBag[0]:Hide(); end
end
if (Event == "MAIL_SHOW") then
if (xBagPerDB.Options.OpenMail) then xBag.Functions.EventBagShow(); end
end
if (Event == "MAIL_CLOSED") then
if (xBag.Frames.ExtraBag[0]:IsShown() and xBagPerDB.Options.CloseMail) then xBag.Frames.ExtraBag[0]:Hide(); end
end
if (Event == "AUCTION_HOUSE_SHOW") then
if (xBagPerDB.Options.OpenAuction) then xBag.Functions.EventBagShow(); end
end
if (Event == "AUCTION_HOUSE_CLOSED") then
if (xBag.Frames.ExtraBag[0]:IsShown() and xBagPerDB.Options.CloseAuction) then xBag.Frames.ExtraBag[0]:Hide(); end
end
if (Event == "GUILDBANKFRAME_OPENED") then
if (xBagPerDB.Options.OpenGuildBank) then xBag.Functions.EventBagShow(); end
end
if (Event == "GUILDBANKFRAME_CLOSED") then
if (xBag.Frames.ExtraBag[0]:IsShown() and xBagPerDB.Options.CloseGuildBank) then xBag.Frames.ExtraBag[0]:Hide(); end
end
if (Event == "BAG_UPDATE_DELAYED") then
if (xBagPerDB.Options.FilterPickupBag and xBag.Frames.ExtraBag) then
if (xBag.Frames.ExtraBag[0]:IsShown()) then
xBag.Functions.RefreshBags(false)
else
for i = 1, xBag.Data.MaxBags do
if (xBag.Frames.ExtraBag[i]:IsShown()) then
xBag.Functions.RefreshBags(false)
break
end
end
end
end
if (xBagPerDB.Options.FilterPickupBank and xBag.Frames.BankBag and xBag.Frames.BankBag[0]:IsShown()) then xBag.Functions.RefreshBags(true); end
if (xBagPerDB.Options.HideEmptyBags) then
for i = 1, xBag.Data.MaxBags do
if (#xBag.Data.BagList[i] == 0 and xBag.Frames.ExtraBag[i]:IsShown()) then xBag.Frames.ExtraBag[i]:Hide(); end
if (#xBag.Data.BankBagList[i] == 0 and xBag.Frames.BankBag[i]:IsShown()) then xBag.Frames.BankBag[i]:Hide(); end
end
end
if (xBag.Data.LootID and xBagPerDB.Options.LootOpen ~= 2) then
for k, v in pairs(xBag.Data.LootID) do
if (v) then
xBag.Data.LootID[k] = nil
local LootOpen
for i = 1, xBag.Data.MaxBags do
if (#xBagPerDB.BagCustomList[i] > 0) then
for x = 1, #xBagPerDB.BagCustomList[i] do
if (xBagPerDB.BagCustomList[i][x] == k) then
LootOpen = i
break
end
end
end
if (LootOpen) then break; end
end
if (not LootOpen) then
for BagIndex = 0, NUM_BAG_SLOTS do
for SlotIndex = 1, GetContainerNumSlots(BagIndex) do
local _, Count, _, Quality, Readable, Lootable, _, _, _, itemID1 = GetContainerItemInfo(BagIndex, SlotIndex)
local itemID2, itemEquipLoc, ClassID, SubClassID
if (itemID1 and itemID1 == k) then itemID2, _, _, itemEquipLoc, _, ClassID, SubClassID = GetItemInfoInstant(itemID1); end
if (itemID2) then
if (xBag.Data.NewFilter and C_NewItems.IsNewItem(BagIndex, SlotIndex)) then
local BagID = xBag.Functions.FilterCheck(19, false)
if (BagID) then
LootOpen = BagID
break
end
end
if (not LootOpen) then
local Check
if (xBag.Functions.FilterCraftingReagent(ClassID)) then Check = 2; elseif (xBag.Functions.FilterReagent(ClassID, SubClassID)) then Check = 3; elseif (xBag.Functions.FilterChest(Lootable)) then Check = 4; elseif (xBag.Functions.FilterGearBags(itemEquipLoc, BagIndex, SlotIndex, true)) then Check = 5; elseif (xBag.Functions.FilterGearBags(itemEquipLoc, BagIndex, SlotIndex, false)) then Check = 6; elseif (xBag.Functions.FilterMountPetToy(ClassID, SubClassID, itemID2)) then Check = 7; elseif (xBag.Functions.FilterAnimaRelics(ClassID, SubClassID, itemID2, xBag.Data.Anima)) then Check = 8; elseif (xBag.Functions.FilterAnimaRelics(ClassID, SubClassID, itemID2, xBag.Data.KorthianRelic)) then Check = 9; elseif (xBag.Functions.FilterKeys(ClassID)) then Check = 10; elseif (xBag.Functions.FilterRecipe(ClassID)) then Check = 11; elseif (xBag.Functions.FilterEnhancement(ClassID)) then Check = 12; elseif (xBag.Functions.FilterConsumable(ClassID, SubClassID, true)) then Check = 13; elseif (xBag.Functions.FilterConsumable(ClassID, SubClassID, false)) then Check = 14; elseif (xBag.Functions.FilterQuest(ClassID)) then Check = 15; elseif (xBag.Functions.FilterReadable(Readable)) then Check = 16; elseif (xBag.Functions.FilterJunk(Quality)) then Check = 17; else Check = 18; end
local BagID = xBag.Functions.FilterCheck(Check, false)
if (BagID) then
LootOpen = BagID
break
end
end
end
end
if (LootOpen) then break; end
end
end
if (LootOpen and ((xBagPerDB.Options.LootOpen == 1 and not xBag.Frames.ExtraBag[LootOpen]:IsShown()) or (xBagPerDB.Options.LootOpen == 3 and xBagPerDB.AlwaysShowBag[LootOpen] and not xBag.Frames.ExtraBag[LootOpen]:IsShown()))) then
local SetBags
if (not xBag.Frames.ExtraBag[0]:IsShown()) then
SetBags = true
for i = 1, xBag.Data.MaxBags do
if (xBag.Frames.ExtraBag[i]:IsShown()) then
SetBags = false
break
end
end
if (SetBags) then
for i = 0, xBag.Data.MaxBags do wipe(xBag.Data.BagList[i]) end
xBag.Functions.OpenCloseBags(false, true)
xBag.Data.CloseCheck = true
wipe(xBag.Data.ExtraBagsOpen)
end
end
xBag.Frames.ExtraBag[LootOpen]:Show()
end
end
end
end
xBag.Data.SlotPickup.BagID, xBag.Data.SlotPickup.SlotID, xBag.Data.SlotPickup.isBank, xBag.Data.SlotPickup.isReagent, xBag.Data.SlotPickup.isInventory = nil, nil, false, nil, nil
end
if (Event == "CHAT_MSG_LOOT") then
local PlayerID = select(11, ...)
if (PlayerID == xBag.Data.PlayerID) then
local LootID = tonumber(select(3, strfind(Self, "item:(%d+)")))
xBag.Data.LootID[LootID] = true
end
end
end
xBag.Frames.Event:SetScript("OnEvent", xBag.Frames.Event.OnEvent)